/* DRM1.C + DRM2.C + DRW1.C + RM001.C + RW001.C */

#define     TBUG    1
#define     T800    1
#define     MLT     1000.

#include   <stdio.h>
#include   <stdlib.h>
#include   <string.h>
#include   <math.h>
#include   <time.h>
#include   <timer.h>
#if         T800
#include   <chan.h> 
#include   <alt.h>
#endif


#define    NODES   41
#define    ELEMS   50

#define    MB      20
#define    ML      5
#define    MM      2
#define    MDIME   3
#define    MSTR    1
#define    MBE     1
#define    MLN   10
#define    TOL_E 10.e-20




struct send{ int nn_g;

int    nn, ne, nb, nm, nl, ndime, kt, nt, nstr, nbe, kmax, nmax, iln, it,
       mat[MM], nc[MLN], nod[6*ELEMS];

int    no_of_sds,t_sds, nn_sd, ne_sd, bsgt, b_nodes;

int    N[NODES],E[ELEMS], mark[NODES*4];

float  t_calc, t_res, t_eng;

double dt, damp, af, b, eng, engl,
       aload[MLN][MDIME], amat[MM][5],
       cord[3*NODES],bb[3*NODES],ols[3*ELEMS],r[3*NODES],
       v[3*NODES], ocord[3*NODES], origcord[3*NODES];
} OUT;


struct send2{int it, peak; double eng;} OUT2;

typedef struct{int b_nod, sub_no[4];} mrk_t;

mrk_t  MRK[30];

FILE     *fpout, *fdebug, *ft;
char      titel[70],file[20],outfile[20];
int       nn, ne, nb, nm, nl, ndime, kt, nt, nstr, nbe, kmax, nmax, iln;
int       nq;
int       mat[MM], *nod, nodl[ML][3], nco[MB][MDIME+1], nc[MLN];
int       it;
double    dt, damp, ff, af, b, eng, engl;
double    aload[MLN][MDIME],amat[MM][5];
double    *cord, *bb, *r, *v, *ok, *ols;
int       *mbc;
double    *rlen, *ocord, *origcord;
double    odl[ML],tt[ML];

double    *ar2,*bm,*rbr;
int       t_sds, nn_sd, ne_sd, iln_sd, *bsgt, **subdoms;
int       nb_sd, b_nodes,xc;

double *stress;

#if   T800
CHAN **in_p, **out_p;
int chans, n_ins, n_outs;
#endif

		void release_all_workers();
		void  integr(void);
		void  final_message(void);
		void  load_cord(void);
		void  locate_elems(int);
		void  locate_nodes(int sub_nodes[]);
		int   p_stack(int ref_node, int sub_nodes[]);
		void  load_boun_first(int sub_nodes[]);
		void  mark_node(int);
		int   mark_node_comp(int,int, int []);
	int   compar(mrk_t *, mrk_t *);
	int   compar_int(int *, int *);
		int   comp_b_nodes(int node);
		int   comp_st(int node, int xx, int boun_flag);
		void  revise_nod(void);
		void  sub_iln(void);
		void  transmit(int ii);
		void  print_peak(int peak, int i);
		void  load_OUT_ID(int sd);
	void  display_orig(char *s);
	void  display(char *s);
	void  ex_double(char *s,double *array, int ii, int jj, int kk);
	void  ex_int(char *s, int *array, int ii, int jj, int kk);
	void  ex_int_vec(char *s, int *vec, int ii);
	void  pr_int(char *s,int vali);
	int   glob_loc(int node);
		int   search_polar(double xm, double ym, double xq, double yq, int ns1, int ns2);
		void  areacord(double x1, double y1, double x2, double y2,
		      double x3, double y3, double x, double y, double *pl1,
		      double *pl2,double *pl3);



main(argc, argv, envp, in_ports, ins, out_ports, outs)

int argc, ins, outs;
char *argv[], *envp[];
#if   T800
CHAN *in_ports[], *out_ports[];
#endif
{  
register i;
int test_size;
clock_t ct1, ct2;
time_t lasttime,curtime, pt1, pt2;


	 test_size = sizeof(OUT);


	 if((fdebug=fopen("debug.dat","w")) == (FILE *) NULL)
	 {printf("cannot open debug.dat\n"); exit(1);}


#if    T800
    in_p = in_ports;
    out_p = out_ports;    
    n_ins = ins;
    n_outs = outs;
#endif

    argc = 2;                    
    if (argc < 2)
    {
      printf("\n Not enough arguments!\n");
      abort();
    }
    argv[1] = "input";           
    strcpy(file,argv[1]);        /* set basic filename to 'file'     */

    data();                      /* input data for FE analysis       */


	open_subdomain_file();       /* read the sub-domain information  */


    leng();                      /* calculate original lengths       */


    mass();                              /* calculate mass matrices          */


    cfree(rlen);


    /*form1();*/                     /* form stiffness matrices          */


    load();                                    /* incorporate applied loads */


    init();                                      /* initial iteration step */


time(&pt1);               /* begin pre-process time */

display_orig("Original data structure");

for(i = 0; i < t_sds; i++)
{
mark_node(i);

locate_elems(i);                     /* load mesh element into sub-domains */

sub_iln();                           /*load in the sub-domain loaded nodes */

load_OUT_ID(i);                      /* load the out going structures   */
transmit(i);                         /* send OUT and rec REFLECTION     */
}
release_all_workers();                    /*allow all worker tasks to begin */
time(&pt2);                               /* end pre-process time */

time(&lasttime);                             /* start time count */
ct1 = clock();

integr();                          /* receive after 100 its or peaks */

release_all_workers();                    /*allow all worker tasks to begin */

final_message();                   /* receive final cords            */

time(&curtime);
ct2 = clock();

    if((stress = calloc(3*ne+1, sizeof(double))) == NULL)
    {printf("out of core for stress\n"); exit(1);}

    print();                     /* output results to OUTPUT.DAT     */

    cfree(stress);

    routput();

    printf("revised input.dat file generated as ** out.dat**\n");
	printf("Processor times in **tim.dat**\n");

    printf("\n\n Time (re-ordering of data) mins = %f\n",(double)(pt2-pt1)/60.);
    fprintf(ft,"\n\n Time (re-ordering of data) mins = %f\n",(double)(pt2-pt1)/60.);
	printf("Total Processor time in secs = %d\n", ct2);
	fprintf(ft,"Total Processor time in secs = %d\n", ct2);
	printf("Time (integr) taken in mins = %f\n",((double)(curtime - lasttime))/60.);
	fprintf(ft,"Time (integr) taken in mins = %f\n",((double)(curtime - lasttime))/60.);


	printf("\a\a\a\a");
	fclose(ft);
	fclose(fdebug);
}


/* Main integration scheme */
void integr(void)
{
int msglen, peak, i, knt,j,ch;

    knt = 0;                 /* counts no. of signals before breaking */

	for(;;){
#if  T800
		msglen = sizeof(OUT2);

		ch = alt_wait_vec(t_sds, &in_p[2]);
	ch += 2;
		chan_in_word(&msglen,in_p[ch]);
		chan_in_message(msglen, &OUT2, in_p[ch]);

		eng  = OUT2.eng;
		it   = OUT2.it;
		peak = OUT2.peak;
#endif
		print_peak(peak, ch-2);

    if(peak == -1 || it == nmax*kmax) knt++;
    if(knt == t_sds)break;
  }

}

void final_message(void)
{
register i,j;
int msg,msglen,ii;
double ct_calc, ct_comm, ct_res, ct_eng, val;

#if     T800

  ct_calc = ct_comm = ct_res = ct_eng = 0.;

  if((ft = fopen("tim.dat", "w")) == (FILE *) NULL) /*OPEN processor times FILE*/
  {printf("cannot open tim.dat\n"); exit(1);}

  msglen = sizeof(OUT);                           /* receive the results*/
  for(i = 0; i < t_sds; i++)
	{
	ii = alt_wait_vec(t_sds, &in_p[2]);
    ii += 2;
    chan_in_word(&msglen, in_p[ii]);
	chan_in_message(msglen, &OUT, in_p[ii]);
	load_cord();
	val=OUT.t_res+OUT.t_eng;
	printf("t_calc=%5.2f t_comm=%5.2f (t_res=%5.2f t_eng=%5.2f) Total PROC(%2d)=%5.2f\n",
	OUT.t_calc, val, OUT.t_res,
	OUT.t_eng, OUT.no_of_sds, OUT.t_calc+val);

	fprintf(ft,"t_calc=%5.2f t_comm=%5.2f (t_res=%5.2f t_eng=%5.2f) Total PROC(%2d)=%5.2f\n",
	OUT.t_calc, val, OUT.t_res,
	OUT.t_eng, OUT.no_of_sds, OUT.t_calc+val);

	}
#endif

}

void load_cord(void)
{
register i,j;
int sub_id, node;


for(i = 0; i < OUT.nn; i++)
	 for(j = 0; j < ndime; j++)
	 {
	 node = OUT.N[i];
	 cord[ndime*(node-1)+j] = OUT.cord[ndime*i+j];
	 }
}


/* function locates the elements for the given boundaries of the
   sub-domains and for each sub domain a list of elements is prepared */

void locate_elems(int i)
{                                                     
register j,k,l;
int ns1,ns2,vali;
int n[3], t_dirnode,flag,  sub_nodes[NODES];
double x[3],y[3],xm,ym, xq,yq;

     xq = 0. ; yq = 0.;
     for(j = 0; j < bsgt[i]; j++){
     ns1 = subdoms[i][2*j+0];
     xq += origcord[ndime*(ns1-1)+0]*MLT;
     yq += origcord[ndime*(ns1-1)+1]*MLT;
     }
     xq = xq/((double) bsgt[i]); 
     yq = yq/((double) bsgt[i]); 
     

	 fprintf(fpout,"\n Elements of Sub Domains %5d\n", i+1);
	 nn_sd = 0;
	 ne_sd = 0;
			 for(j = 0; j < ne; j++)
			 {
				 elemcord(j,n,x,y);
		 for(l = 0; l < 3; l++){ x[l] = MLT*x[l]; y[l] = MLT*y[l];}
				 xm = (x[0] + x[1] + x[2])/3.;
				 ym = (y[0] + y[1] + y[2])/3.;

	 for(k = 0; k < bsgt[i]; k++)
	 {
	    ns1 = subdoms[i][2*k+0];  ns2 = subdoms[i][2*k+1];

	    t_dirnode = search_polar(xm, ym, xq, yq, ns1, ns2);

	    flag = 1;

	    if(t_dirnode == -1) { flag = 0; break;}

	  }
       if(flag == 1) continue;
       OUT.E[ne_sd] = j+1;
       ne_sd++;
       fprintf(fpout,"%5d",j+1);
       }
   fprintf(fpout,"\n");

   locate_nodes(sub_nodes);
   load_boun_first(sub_nodes);
   revise_nod();
   
return;
}      


/* function arranges cord[] for the elements of sub-domain */

/* function compares the boundary segments of the sub-domain under reference
with those of other sub-domains and loads OUT.mark which has its rows for
each commom boundary node and the columns for the common sub-domain numbers*/

void mark_node(int sub_domain)
{
register i, ii, j;
int mark[4], ref_node, test;

OUT.b_nodes = 0;
b_nodes = 0;

for(i = 0; i < bsgt[sub_domain]; i++)
{
ref_node = subdoms[sub_domain][2*i + 0] - 1;

for(ii = 0; ii < 4; mark[ii++] = 0);

test = mark_node_comp(ref_node, sub_domain, mark);

  if(test > 0)
  {
    MRK[b_nodes].b_nod  = ref_node+1; /*load global node number */
    for(j = 0; j < 4; j++)
    MRK[b_nodes].sub_no[j] = mark[j];      /*load the sub-domain number */
    b_nodes++;
    OUT.b_nodes++;
  }
}
				      

qsort(MRK, b_nodes, sizeof(MRK[0]), compar);

for(i = 0; i < b_nodes; i++) /* load field mark[] of buffer OUT */
  for(j = 0; j < 4; j++)
  {
  OUT.mark[4*i+j] = MRK[i].sub_no[j];
  }

}

int compar(mrk_t *d1, mrk_t *d2)
{
if(d1->b_nod < d2->b_nod) return -1;
if(d1->b_nod > d2->b_nod) return 1;
return 0;
}

/* function to compare the reference node with boundary nodes of other
sub-domains.  The function returns the sub-domain number for a common
boundary node else 0 */ 

int mark_node_comp(int ref_node, int sub_domain, int test[])
{
register i,j;
int vali, knt;
knt = 0;
for(i = 0; i < t_sds; i++)
{
if(i == sub_domain) continue;
   for(j = 0; j < bsgt[i]; j++)
	 {
	 vali = subdoms[i][2*j + 0];
	 if((ref_node+1) == subdoms[i][2*j + 0]){test[knt] = i+1;knt++;break;}
	 if((ref_node+1) == subdoms[i][2*j + 1]){test[knt] = i+1;knt++;break;}
	 }
}
return(knt);
}    



void locate_nodes(int sub_nodes[])
{
int i,j,k,ii, ref_node, test;
int vali;
double val;

for(i = 0 ; i < nn; i++)
  for(j = 0; j < ne_sd; j++)
    for(k = 0; k < 3; k++)
    {
	 vali = OUT.E[j]-1;
  
		 ref_node = nod[6*vali + k] - 1;

	 if(ref_node == i) 
	 {
	 test = p_stack(ref_node,sub_nodes);/* for previously loaded nodes 1 else 0*/
	 if(test > 0) continue;
	 sub_nodes[nn_sd] = i+1;
	 nn_sd++;
	 }
   
    }
qsort(sub_nodes,nn_sd,sizeof(int),compar_int);
}

int compar_int(int *d1, int *d2)
{
if(*d1 < *d2) return -1;
if(*d1 > *d2) return 1;
return 0;
}

int p_stack(int ref_node, int sub_nodes[])
{
int i, vali, node;
for(i = 0; i < nn_sd; i++)
{
node = sub_nodes[i]-1;
if(ref_node == node) return(1);
}
return(0);
}


void load_boun_first(int sub_nodes[])
{
int i,j,k,xx,test1, ref_node, temp, xb,xn;
int vali;
double val;    /* nn_sd, ne_sd, cord, OUT.cord, nod, OUT.nod are GLOBAL */

   xx = 0;
   xb = 0;
   xn = 0;
   for(i = 0; i < nn_sd; i++)
   {
	test1 = 0;  
    ref_node = sub_nodes[i] -1;
	if((test1 = comp_b_nodes(ref_node)) > 0)  /*check for boundary node */
    {
    xx = xb;
    OUT.N[xx] = ref_node+1;
	   for(j = 0; j < 3; j++)
	   {
	    val =     OUT.cord[3*xx + j] =     cord[3*ref_node + j];
	    val =       OUT.bb[3*xx + j] =       bb[3*ref_node + j];
	    val =        OUT.r[3*xx + j] =        r[3*ref_node + j];
	    val =        OUT.v[3*xx + j] =        v[3*ref_node + j];
	    val =    OUT.ocord[3*xx + j] =    ocord[3*ref_node + j];
	    val = OUT.origcord[3*xx + j] = origcord[3*ref_node + j];
	   }
    xb++;
    }
    else
    {
    xx = xn + b_nodes;
    OUT.N[xx] = ref_node+1;
	   for(j = 0; j < 3; j++)
	   {
	    val =     OUT.cord[3*xx + j] =     cord[3*ref_node + j];
	    val =       OUT.bb[3*xx + j] =       bb[3*ref_node + j];
	    val =        OUT.r[3*xx + j] =        r[3*ref_node + j];
	    val =        OUT.v[3*xx + j] =        v[3*ref_node + j];
	    val =    OUT.ocord[3*xx + j] =    ocord[3*ref_node + j];
	    val = OUT.origcord[3*xx + j] = origcord[3*ref_node + j];
	   }
    xn++;
   }
 }
return;
}

int comp_b_nodes(int node) /*node is global numbered*/
{
register i;
for(i = 0; i < b_nodes; i++)
if(MRK[i].b_nod == (node+1)) return(node+1);
return(0);
}


/* function to revise the node topology */

void revise_nod(void)
{
int vali, i, j, k, node, elem;
   for(i = 0; i < ne_sd; i++)
   {
      elem = OUT.E[i] - 1;     /*global number - 1*/
      for(j = 0; j < 3; j++)
      {
      node = glob_loc(nod[6*elem+j]);/*load the local node number*/
      vali = OUT.nod[6*i+j] = node;
      vali = OUT.ols[3*i + j] = ols[3*elem + j];         /*load ols */
      }


   }
return;
}


/* function to load the loaded nodes  for the sub-domain*/
void sub_iln(void)
{
register i, j, k;
int vali, node;
double val, div;

iln_sd = 0;

if(iln > 0)
for(i = 0; i < iln; i++)
{
   for( j = 0; j < nn_sd; j++)
   {
	 if((node = OUT.N[j]) == nc[i]) 
	 {
	    if(comp_b_nodes(node-1) > 0)  div= 2.; else div = 1.; /*for singly connected sub-domain node*/
				 vali = OUT.nc[iln_sd] = glob_loc(nc[i]);
				 for(k = 0; k < 3; k++){
				 val = OUT.aload[iln_sd][k] = aload[i][k]/div;
				 }
				 iln_sd++;
				 continue;
				 }
	 }
}
return;
}

/* function sends the data structures
   OUT  from its out_p[2] to the worker task  waiting at its
   in_p[0]. */

void transmit(int ii)
{
int msglen,i;

#if      T800
     msglen = sizeof(OUT);
     chan_out_word(msglen, out_p[2+ii]);
     chan_out_message(msglen, &OUT, out_p[2+ii]);      /* OUT gone  */


     /* get back OUT  */
     alt_wait(1, in_p[2+ii]);
     chan_in_word(&msglen,in_p[2+ii]);
	 chan_in_message(msglen, &OUT, in_p[2+ii]);

	 printf("Reflection from subdomain no. %d\n", ii);
	 fprintf(fdebug,"Reflection from subdomain no. %d\n", ii);
	 display("Rearranged data of the Subdomain");


#endif

return;
}
 

/* function checks the value of peak and prints results accordingly */

void print_peak(int peak, int i)
{
    if(peak == 1){
	fprintf(fpout,"\n\n PROC %2d *Energy Peak* at ITERATION  %6d,\
	    Energy = %10.5e \n",i,it, eng);

	printf("\n\n PROC %2d *Energy Peak* at ITERATION  %6d,\
	    Energy = %10.5e \n",i,it, eng);
    }else{
	fprintf(fpout,"\n\n PROC %2d ****  ITERATION  %6d,  Energy = %10.5e \n",
			i,it, eng);
    printf("\n\n PROC %2d **** ITERATION  %6d,  Energy = %10.5e \n",
			i,it, eng);
    }
return;
}




/* function loads the stuctures OUT */

void load_OUT_ID(int sd)
{
register i;
int vali;
int loc;
double val;


   OUT.nn_g = nn;

   OUT.nn=nn_sd; OUT.ne=ne_sd; OUT.nb=nb; 

   OUT.nm=nm; OUT.nl=nl;OUT.ndime=ndime;

   OUT.kt=kt; OUT.nt=nt; OUT.nstr=nstr; OUT.nbe=nbe; OUT.kmax=kmax;

   OUT.nmax=nmax; OUT.iln=iln_sd; OUT.it=it;
 
   OUT.no_of_sds= sd+1;  OUT.bsgt=bsgt[sd];

   OUT.nn_sd = nn_sd;  OUT.ne_sd = ne_sd;

   OUT.t_sds = t_sds;

   memmove(OUT.mat, mat, vali = sizeof(mat));
   memmove(OUT.amat, amat, sizeof(amat));

   OUT.dt=dt; OUT.damp=damp; OUT.af=af; OUT.b=b; OUT.eng=eng; OUT.engl=engl;

return;
}


/*function converts the global node number to local sub-domain node
 number, on error returns 1 */

int glob_loc(int node)
{
register i;

for(i = 0; i < nn_sd; i++)
if(OUT.N[i] == node) return(i+1);

return(-1);
}



int search_polar(double xm, double ym, double xq, double yq, int ns1, int ns2)
{
double x[3], y[3], l[3];
   

   x[2] = xq; 
   x[0] = MLT*origcord[ndime*(ns1-1)+0];  
   x[1] = MLT*origcord[ndime*(ns2-1)+0];
   y[2] = yq; 
   y[0] = MLT*origcord[ndime*(ns1-1)+1];  
   y[1] = MLT*origcord[ndime*(ns2-1)+1];
      
   areacord(x[0],y[0], x[1], y[1], x[2], y[2], xm,ym,
   &l[0], &l[1], &l[2]);
   if(fabs(l[0]) <= pow(10.,-4))
   l[0] = 0.;
   if(fabs(l[1]) <= pow(10.,-4))
   l[1] = 0.;
   if(fabs(l[2]) <= pow(10.,-4))
   l[2] = 0.;

   if(fabs(l[0] - 1.) <= pow(10.,-4))
   l[0] = 1.;
   if(fabs(l[1] - 1.) <= pow(10.,-4))
   l[1] = 1.;
   if(fabs(l[2] - 1.) <= pow(10.,-4))
   l[2] = 1.;

   if(l[0] >= 0. && l[1] >= 0. && l[2] >= 0. && l[0] <= 1. && l[1] <= 1.
   && l[2] <= 1.)
   return(-1);
   


return(1);

}

void areacord(double x1, double y1, double x2, double y2,
	      double x3, double y3, double x, double y, double *pl1,
	      double *pl2,double *pl3)

{
double area,a1,a2,a3;

      area=(x2*y3-x3*y2)-(x1*y3-x3*y1)+(x1*y2-x2*y1);

      a1=(x2*y3-x3*y2)+x*(y2-y3)+y*(x3-x2);
      a2=(x3*y1-x1*y3)+x*(y3-y1)+y*(x1-x3);
      a3=(x1*y2-x2*y1)+x*(y1-y2)+y*(x2-x1);

      *pl1=a1/area;
      *pl2=a2/area;
      *pl3=a3/area;
return;
}

void release_all_workers()
{
register i;
int msglen;

msglen = sizeof(msglen);


chan_out_word(msglen, out_p[2]);   /* sync signal to first subdomain */
chan_out_message(msglen, (char *) &msglen, out_p[2]);
}


/* debug.c*/
void display_orig(char *s)
{
    fprintf(fdebug,"\n\n *** %s *** \n\n", s);
    printf("\n\n *** %s *** \n\n", s);
    ex_double("bb",bb, 0, nn, ndime);
    ex_double("cord",cord, 0, nn, ndime);
    ex_double("ocord",ocord, 0, nn, ndime);
    ex_double("origcord",origcord, 0, nn, ndime);
    ex_double("ols", ols, 0, ne, 3);
    ex_double("ok",ok, 1, 6, 6);/*for 1st elem only */
    ex_double("r",r, 0, nn, ndime);
    ex_double("v ",v, 0, nn, ndime);/* ex OUT  */
    ex_int_vec("nc",nc,iln);
    ex_int_vec("mat", mat, nm);
    ex_int("mbc", mbc, 0, ne, 4);
    ex_int("nod",nod, 0, ne, 6);
    pr_int("nn = ",nn);
    pr_int("ne = ",ne);
    pr_int("iln = ",iln);
    pr_int("nn_sd = ",nn_sd);
    pr_int("ne_sd = ",ne_sd);
    pr_int("t_sds = ",t_sds);  /* display the confirm back */

return;
}


void display(char *s)
{
    fprintf(fdebug,"\n\n *** %s *** \n\n", s);
		ex_int_vec("OUT.N[]",OUT.N, OUT.nn);
		ex_int_vec("OUT.E[]",OUT.E, OUT.ne); 
		ex_int("OUT.mark",OUT.mark, 0, OUT.b_nodes, 4);
		ex_double("OUT.bb",OUT.bb, 0, OUT.nn, OUT.ndime);
		ex_double("OUT.cord",OUT.cord, 0, OUT.nn, OUT.ndime);
		ex_double("OUT.ocord",OUT.ocord, 0, OUT.nn, OUT.ndime);
		ex_double("OUT.origcord",OUT.origcord, 0, OUT.nn, OUT.ndime);
		ex_double("OUT.ols", OUT.ols, 0, OUT.ne, 3);
		ex_double("OUT.r",OUT.r, 0, OUT.nn, OUT.ndime);
		ex_double("OUT.v ",OUT.v, 0, OUT.nn, OUT.ndime);/* ex OUT  */
		ex_int_vec("OUT.nc",OUT.nc,OUT.iln);
		ex_int_vec("OUT.mat", mat, OUT.nm);
		ex_int("OUT.nod",OUT.nod, 0, OUT.ne_sd, 6);
		pr_int("OUT.nn = ",OUT.nn);
		pr_int("OUT.ne = ",OUT.ne);
		pr_int("OUT.iln = ",OUT.iln);
		pr_int("OUT.nn_sd = ",OUT.nn_sd);
		pr_int("OUT.ne_sd = ",OUT.ne_sd);
		pr_int("OUT.no_of_sds = ",OUT.no_of_sds);  /* display the confirm back */

return;
}

void ex_double(char *s,double *array, int ii, int jj, int kk)
{
register i = 0,j = 0,k = 0;
double val;

  fprintf(fdebug,"%s\n\n",s);

  if( ii > 0)
  for(i = 0; i < ii; i++){
  fprintf(fdebug,"elem no. %5d\n",i+1);
    for(j = 0; j < jj; j++) {
    fprintf(fdebug,"%5d",j+1);
      for(k = 0; k < kk; k++) {
	 val = array[jj*jj*i + kk*j + k];
	 fprintf(fdebug,"%12.5e",val);
	  }
     fprintf(fdebug,"\n");
     } 
   fprintf(fdebug,"\n");
   }
   else
   for(j = 0; j < jj; j++) {
   fprintf(fdebug,"%5d",j+1);
      for(k = 0; k < kk; k++) {
	 val = array[jj*jj*i + kk*j + k];
	 fprintf(fdebug,"%12.5e", val);
	  }
   fprintf(fdebug,"\n");
   }
fprintf(fdebug,"\n\n");
return;
}


void ex_int(char *s, int *array, int ii, int jj, int kk)
{
register i = 0,j = 0,k = 0;
int vali;

   fprintf(fdebug,"%s\n\n",s);

  if( ii > 0)
  for(i = 0; i < ii; i++){
    for(j = 0; j < jj; j++) {
      for(k = 0; k < kk; k++) {
	 vali = array[jj*jj*i + kk*j + k];
	 fprintf(fdebug,"%5d",vali);
	  }
     fprintf(fdebug,"\n");
     } 
   fprintf(fdebug,"\n");
   }
   else
   for(j = 0; j < jj; j++) {
   fprintf(fdebug,"%5d",j+1);
      for(k = 0; k < kk; k++) {
	 vali = array[jj*jj*i + kk*j + k];
	 fprintf(fdebug,"%5d",vali);
	  }
   fprintf(fdebug,"\n");
   }
fprintf(fdebug,"\n\n");
return;
}

void ex_int_vec(char *s, int *vec, int ii)
{
register i;
int vali;
   fprintf(fdebug,"%s\n\n",s);
   for(i = 0; i < ii ; i++)
   {
   vali = vec[i];
   fprintf(fdebug,"%5d %5d\n",i+1,vec[i]);
   }
return;
}


void pr_double(char *s,double val)
{
   fprintf(fdebug,"%s %12.5e\n\n",s,val);
return;
}

void pr_int(char *s,int vali)
{
  fprintf(fdebug,"%s %5d\n\n",s,vali);
return;
}


