#define     ALT     0
#define     T800    1

#include   <stdio.h>
#include   <stdlib.h>
#include   <string.h>
#include   <math.h>
#define    XX  extern


#define    NODES   41
#define    ELEMS   50

#define    MB    20
#define    ML      5
#define    MM      2
#define    MDIME   3
#define    MSTR    1
#define    MBE     1
#define    MLN   10
#define    TOL_E 10.e-20






XX struct send{ int nn_g;

int    nn, ne, nb, nm, nl, ndime, kt, nt, nstr, nbe, kmax, nmax, iln, 
			 it, mat[MM], nc[MLN], nod[6*ELEMS];

int    no_of_sds,t_sds, nn_sd, ne_sd, bsgt, b_nodes;

int    N[NODES],E[ELEMS],mark[NODES*4]; /* local to global direct*/
																      
float  t_calc, t_res, t_eng;

double dt, damp, af, b, eng, engl, aload[MLN][MDIME], amat[MM][5], 
       cord[3*NODES],bb[3*NODES],ols[3*ELEMS],r[3*NODES],
       v[3*NODES], ocord[3*NODES], origcord[3*NODES];
} OUT;



XX FILE     *fpout;
XX char      titel[70],file[20],outfile[20];
XX int       nn, ne, nb, nm, nl, ndime, kt, nt, nstr, nbe, kmax, nmax, iln;
XX int       nq;
XX int       mat[MM], *nod, nodl[ML][3], nco[MB][MDIME+1], nc[MLN];
XX int       it;
XX double    dt, damp, ff, af, b, eng, engl;
XX double    aload[MLN][MDIME],amat[MM][5];
XX double    *cord, *bb, *r, *v, *ok, *ols;
XX int       *mbc;
XX double    *rlen, *ocord, *origcord;
XX double    odl[ML],tt[ML];

XX double    *ar2,*bm,*rbr;
XX int       t_sds, nn_sd, ne_sd, iln_sd, *bsgt, **subdoms;
XX int       nb_sd, b_nodes;

XX double *stress;


void bform(void);
void init(void);
void pform(void);
void form1(void);
void sidelen();
void leng(void);
void mass(void);
void load(void);
void print(void);
void pr_cen_stress(double stress[]);
void rota(void);
void open_subdomain_file(void);
void alt_load(void);
void alt_unload();
void  adjel1(void);
void  adjel1_sub(void);
void  bound(void);
void  bound_sub(void);
void  elemcord(int n,int nn[], double x[], double y[]);
void  nodecord(int node, double *px, double *py); 
void  routput(void);

/*  Form virtual rotation, real curvature and bending moment matrices  */
/*  for each triangle, put in restraint conditions at the same time    */
void bform(void)
{
		     /* SUBROUTINE BFORM */

    int         l,nq,is,lbc,ja,ic,jop,kc,kr,kd,jc,kx,
		km,ke,i,j,ib,nr,id,jb,ndim,kbug,jex[3];
    double       e,vv,th;
    double       hl,hlr[3],bv[3][3],br[3][6];  /* moved from common */
    double       dl[3],ds,st[3][6],stif[3][6];        /*      block */



    kbug  =  0;
    if (kbug > 0)
      fprintf(fpout,"\n\n *******  SUBROUTINE FORM  *******\n");

    for (l=0; l<ne; ++l)
      for (i=3; i<6; ++i)
	for (j=0; j<6; ok[36*l+6*i+j++] = 0.00);

    for (l=0; l<ne; ++l)  {
      if (kbug > 1)
	fprintf(fpout,"\n ELEMENT = %5d\n",l+1);
      nq  =  mbc[4*l+3] - 1;
      e   =  amat[nq][0];
      vv  =  amat[nq][1];
      th  =  amat[nq][2]/1000.00;

      ds  =  ff * e * pow(th,3) / (24.0 * (1.0 - vv*vv));  /* elasticity */
      if (kbug > 1)
	fprintf(fpout,"\n  DS = %15.5f\n", ds);

      for (is=0; is<3; ++is) {              /* Consider each side in turn */
	lbc  =  mbc[4*l+is];
	/* Check adjacent element number, or side restraint code.         */
	/* [clamped: -200, symmetrical: -222, free: -111, s/s: -100]      */
	if (lbc >= 0)
	  /* Determine node order in adjacent triangle on each side       */
	  /* For i,j,k determine nodes e, f or g and the node destination */
	  /* vector for each side                                         */
	{
	  for (ja=0; ja<3; ++ja) {
	    for (ic=0; ic<3; ++ic) {
	      if (nod[6*l+ic] == nod[6*(lbc-1)+ja]) {
		jex[ja]  =  ic;
		break;
	      }
	      else if (ic == 2) {
		jop  =  ja;
		jex[ja]  =  is + 3;
		nod[6*l+jex[ja]]  =  nod[6*(lbc-1)+jop];
	      }
	    }
	  }
	  hl      =  ar2[l]/ols[3*l+is] + ar2[lbc-1]/ols[3*(lbc-1)+jop];
	  hlr[is] =  1.0/hl;

	  /* Form virtual rotation */
	  for (kc=0; kc<3; ++kc) {
	    kr  =  (is)*3 + kc;
	    bv[is][kc]  =  rbr[9*l+kr];
	  }
	  /* Form real curvature   */
	  for (kd=0; kd<6; br[is][kd++] = 0.0);     /* initialise br */
	  for (kc=0; kc<3; ++kc)
	    br[is][kc]  =  hlr[is] * bv[is][kc];
	  for (jc=0; jc<3; ++jc) {
	    ic  =  jex[jc];
	    kx  =  jop*3 + jc;
	    br[is][ic]  +=  hlr[is] * rbr[9*(lbc-1)+kx];
	  }
	}
	else {
	  /* For symmetrical, clamped, s/s or free edges a */
	  /* mirror image is assumed                       */
	  hl      =  2.0 * ar2[l] / ols[3*l+is];
	  hlr[is] =  1.0 / hl;

	  /* Form virtual rotation */
	  for (kc=0; kc<3; ++kc) {
	    kr  =  (is)*3 + kc;
	    bv[is][kc]  =  rbr[9*l+kr];
	  }
	  if (lbc <= -200) {   /* symm. or clamped - form real curvature */
	    for (kc=0; kc<6; br[is][kc++]  =  0.0);     /* initialise br */
	    for (kc=0; kc<3; ++kc)
	      br[is][kc]  =  hlr[is] * bv[is][kc];
	    for (jc=0; jc<3; ++jc)
	      br[is][jc]  *=  2.0;
	    nod[6*l+(is+3)]  =  0;  }
	  else {               /* free or s/s - form real zero curvature */
	    for (kc=0; kc<6; br[is][kc++] = 0.0);
	    nod[6*l+(is+3)]  =  0;
	  }
	}
	if (kbug > 2)
	  fprintf(fpout,"  bv[%3d][*] = %8.4f %8.4f %8.4f \n",
			    is, bv[is][0], bv[is][1], bv[is][2]);
	if (kbug > 1)
	  fprintf(fpout,"  BR[%3d][*] = %8.4f %8.4f %8.4f %8.4f %8.4f %8.4f\n",
			 is, br[is][0], br[is][1],
			 br[is][2],br[is][3],br[is][4],br[is][5]);

	/*  Form bending moment matrix for each side of triangle */
	dl[is]  =  ds * ols[3*l+is];
	if (kbug > 1)
	  fprintf(fpout,"  DL[%3d] = %12.5f\n",is,dl[is]);

	for (kd=0; kd<6; ++kd) {
	  st[is][kd]   =  0.0;
	  stif[is][kd] =  0.0;
	  km  =  is*6 + kd;
	  bm[18*l+km]  =  dl[is] * br[is][kd];
	  st[is][kd] =  bm[18*l+km];
	}
      }
      /* Form stiffness matrix of triangle */
      for (kc=0; kc<3; ++kc)
	for (kd=0; kd<6; ++kd)
	  for (ke=0; ke<3; ++ke)
	    stif[kc][kd]  +=  bv[ke][kc] * st[ke][kd];
      if (kbug > 1) {
	for (i=0; i<3; ++i)
	  fprintf(fpout,"  stif[%3d][*] = %8.4f%8.4f%8.4f%8.4f%8.4f%8.4f\n",
		  i,stif[i][0],stif[i][1],
		  stif[i][2],stif[i][3],stif[i][4],stif[i][5]);
      }

      /* Assemble element stiffness into global stiffness matrix  */
      /* using the node destination vector nod[ne][6].            */
      for (kc=0; kc<3; ++kc) {
	i  =  nod[6*l+kc] - 1;
	for (kd=0; kd<6; ++kd) {
	  j  =  nod[6*l+kd] - 1;
	}
      }
      for (kc=0; kc<3; ++kc)
	for (kd=0; kd<6; ++kd)
	  ok[36*l+6*(kc+3)+kd] = stif[kc][kd];

    }/* next triangle */

    /* Include node support conditions -- zero deflections */
    /* rotations have already been accounted for           */
    for (ib=0; ib<nb; ++ib)
      if (fmod(nco[ib][1],10) > 0) {
	nr  =  nco[ib][0] - 1;
	ndim = 1;                     /* Temporary replacement for ndime */
	for (id=0; id<ndim; ++id) {
	  jb  =  nr*ndim + id;
	}
      }
    if (kbug > 1) {
      fprintf(fpout,"\n\n Global Stiffness Matrix - ASK[nn][nn]\n");
      for (i=0; i<nn; ++i)
      for (l=0; l<ne; ++l) {
	fprintf(fpout,"\n Stiffness Matrix OK[%3d][*][*]:\n",l+1);
	for (i=3; i<6; ++i)
	  fprintf(fpout,"    %12.5e%12.5e%12.5e%12.5e%12.5e%12.5e\n",
			ok[36*l+6*i+0],ok[36*l+6*i+1],
			ok[36*l+6*i+2],ok[36*l+6*i+3],ok[36*l+6*i+4],ok[36*l+6*i+5]);
      }
    }
}

/* Initial iteration step */
void init(void)
{
    int      in,idime;
    double    dby2, val;

    dby2  =  damp/2.0;
    af = (1.0-dby2) / (1.0+dby2);
    b  = 1.0 / (1.0+dby2);


    for (in=0; in<nn; ++in) {
      for (idime=0; idime<ndime; ++idime) {
	ocord[ndime*in+idime] = cord[ndime*in+idime];
	val = cord[ndime*in+idime] += (dt*dt * r[ndime*in+idime]) 
    / (2.0*bb[ndime*in+idime]);
	v[ndime*in+idime] = 0.0;
      }
    }
}


/*  Form virtual rotation, real curvature and bending moment matrices  */
/*  for each triangle, put in restraint conditions at the same time    */
void form1(void)
{
		     /* SUBROUTINE FORM1 */

    int    kbug;

    kbug  =  0;
    if (kbug > 0)
      fprintf(fpout,"\n\n *******  SUBROUTINE FORM1  *******\n");


    pform();                   /* Form in-plane stiffness matrices */
    
    rota();                    /* Form bending stiffness matrices  */
    bform();
    
}






/* Calculate side lengths */
void leng(void)
{
    int    l,ie,mt,nlt,n1,n2,k,nss,kbug;
    double  dl,dif,d[3],len2, *tlen;

    if((tlen = calloc(3*ne+1, sizeof(double))) == NULL)
    {printf("out of core for tlen\n"); exit(1);}

    kbug = 0;
    if (kbug > 0)
      fprintf(fpout,"\n\n **********  SUBROUTINE LENG  **********\n");

    if (nl > 0) {
      for (l=0; l<nl; ++l) {           /* Link lengths                    */
	if (rlen[l] > 0.00001)
	  odl[l] = rlen[l];            /* direct from input               */
	else {
	  mt = nodl[l][2];
	  nlt = mat[mt];
	}
	if (nlt == 3)
	  odl[l] = amat[mt][3];        /* read as material property       */
	else {
	  n1 = nod[6*l+0]-1;            /* calculate from initial geometry */
	  n2 = nod[6*l+1]-1;
	  dl = 0.0;
	  for (k=0; k<ndime; ++k) {
	    d[k]  =  cord[ndime*n2+k] - cord[ndime*n1+k];
	    dl += d[k]*d[k];
	  }
	  odl[l]  =  sqrt(dl);
	}
      }
    }
    if (ne > 0) {                      /*  Triangle side lengths          */
      for (l=0; l<ne; ++l) {
	mt = mbc[4*l+3]-1;
	nlt = mat[mt];
	for (nss=0; nss<3; ++nss) {
	  if (tlen[3*l+nss] > 0.00001)
	    ols[3*l+nss] = tlen[3*l+nss];
	  else if (nlt == 3)
	    ols[3*l+nss] = amat[mt][nss+4];          /* from material data */
	  else {                       /* calculate from initial geometry */
	    (nss > 1) ? (n1 = nod[6*l+(nss-2)]-1) : (n1 = nod[6*l+(nss+1)]-1);
	    (nss > 0) ? (n2 = nod[6*l+(nss-1)]-1) : (n2 = nod[6*l+(nss+2)]-1);
	    dl = 0.0;
	    for (k=0; k<ndime; ++k) {
	      dif  =  cord[ndime*n2+k] - cord[ndime*n1+k];
	      dl +=  dif * dif;
	    }
	    ols[3*l+nss] = sqrt(dl);
	  }
	}
      }
      if (kbug > 0) {
	fprintf(fpout,"\n element                side lengths \n");
	for (ie=0; ie<ne; ++ie)
	  fprintf(fpout,"  %5d    %15.5f %15.5f %15.5f\n",
			 ie+1, ols[3*ie+0], ols[3*ie+1], ols[3*ie+2]);
      }
    }
}

/* Calculate sidelengths of element n1,n2,n3 */
void sidelen (int n1,int n2,int n3,double slen[3],double templ[3][3])
{
    int    i,idime;
    double  tl;

    for (i=0; i<3; slen[i++] = 0.0);

    for (idime=0; idime<ndime; ++idime)
    {
      templ[0][idime] = cord[ndime*n3+idime] - cord[ndime*n2+idime];
      templ[1][idime] = cord[ndime*n1+idime] - cord[ndime*n3+idime];
      templ[2][idime] = cord[ndime*n2+idime] - cord[ndime*n1+idime];
    }
    for (i=0; i<3; ++i)
    {
      tl = 0.0;
      for (idime=0; idime<ndime; ++idime)
	tl  +=  templ[i][idime] * templ[i][idime];
      slen[i]  =  sqrt(tl);
    }
}

/* calculate mass matrices */
void mass(void)
{
    int      in,idime,il,n,n1,n2,n3,kbug,l,mt,k,node;
    double    elmass,a,dens,rl,tmass,thic,rl1,rl2,rl3,elar,sum;

    kbug = 0;
    if (kbug > 0)
      fprintf(fpout,"\n **********  SUBROUTINE MASS  **********\n");

    for (in=0; in<nn; ++in)              /* Initialise mass matrix bb[][] */
      for (idime=0; idime<ndime; bb[ndime*in+idime++]=0.0);

    if (nl > 0)                            /* Calculate masses for links  */
      for (il=0; il<nl; ++nl) {
	n = nodl[il][2]-1;
	n1 = nodl[il][0]-1;
	n2 = nodl[il][1]-1;
	a  = amat[n][1];
	dens = amat[n][4];
	rl = rlen[il];
	tmass  =  a * rl * dens;
	for (idime=0; idime<ndime; ++idime) {
	  bb[ndime*n1+idime] += tmass/2.0;
	  bb[ndime*n2+idime] += tmass/2.0;
    } }
    if (ne > 0) {                       /* Calculate masses for triangles */
      for (l=0; l<ne; ++l) {
	mt = mbc[4*l+3]-1;
	n1 = nod[6*l+0]-1;
	n2 = nod[6*l+1]-1;
	n3 = nod[6*l+2]-1;
	thic = amat[mt][2]/1000.00;
	dens = amat[mt][4];
	rl1 = ols[3*l+0];
	rl2 = ols[3*l+1];
	rl3 = ols[3*l+2];
	sum  =  (rl1 + rl2 + rl3)/2.0;
	elar =  sqrt(sum * (sum-rl1) * (sum-rl2) * (sum-rl3));
	elmass  =  thic * dens * elar;
	for (k=0; k<ndime; ++k) {
	  bb[ndime*n1+k] += elmass/3.0;
	  bb[ndime*n2+k] += elmass/3.0;
	  bb[ndime*n3+k] += elmass/3.0;
	}
      }
      for (n=0; n<nb; ++n) {          /* Incorporate boundary conditions   */
	node = nco[n][0]-1;
	for (k=1; k<=ndime; ++k)
	  if (fmod(nco[n][k],10) > 0)
	    bb[ndime*node+k-1] = 10.0e25;
      }
    }
    if (kbug > 0) {
      fprintf(fpout,"\n element                masses \n");
      for (in=0; in<nn; ++in)
	fprintf(fpout,"  %5d    %15.5e %15.5e %15.5e\n",
		 in+1, bb[ndime*in+0], bb[ndime*in+1], bb[ndime*in+2]);
    }
}


/*  Form stiffness matrices for in-plane action of elements and add b'c's */
void pform(void)
{
		     /* SUBROUTINE PFORM */

    int          kbug,nq,in,l,n1,n2,n3,i,j,mt,k;
    double       e,vv,th,dtl[3],dtt[3][3],sum,pie,anx,bot,dd[3][3];
    double       ax[3],bx[3],cx[3],ang[3],anax[3],rint[3][3],g[3][3];
    double       thic,com,s,area,at;

    kbug  =  0;
    if (kbug > 0)
      fprintf(fpout,"\n\n *******  SUBROUTINE PFORM  *******\n");

    for (l=0; l<ne; ++l)                    /* For each element           */
    {
      if (kbug > 1)
	fprintf(fpout,"\n ELEMENT = %5d\n",l+1);
      nq  =  mbc[4*l+3] - 1;
      e   =  amat[nq][0];
      vv  =  amat[nq][1];
      thic  =  amat[nq][2]/1000.00;

      n1 = nod[6*l+0] - 1;
      n2 = nod[6*l+1] - 1;
      n3 = nod[6*l+2] - 1;
      sidelen(n1,n2,n3,dtl,dtt);

      sum = 0;                              /* Calculate internal angles  */
      for (i=0; i<3; i++)
	sum += dtl[i]*dtl[i];
      ang[0] = acos((sum - 2.0*dtl[0]*dtl[0]) / (2.0*dtl[1]*dtl[2]));
      ang[1] = acos((sum - 2.0*dtl[1]*dtl[1]) / (2.0*dtl[0]*dtl[2]));
      ang[2] = acos((sum - 2.0*dtl[2]*dtl[2]) / (2.0*dtl[1]*dtl[0]));
      pie = atan(1.0) * 4.0;
      anax[0] = 0.0;                   /* Transformation angles to give   */
      anax[1] = pie - ang[2];          /* side rotations to x-y axes.     */
      anax[2] = pie + ang[1];
      for (j=0; j<3; ++j)
      {
	anx = anax[j];
	ax[j] = cos(anx) * cos(anx);
	bx[j] = sin(anx) * sin(anx);
	cx[j] = sin(anx) * cos(anx);
      }
      /* Evaluate Transformation matrix */
      bot =  ax[0] * (bx[1]*cx[2] - cx[1]*bx[2])
	    -bx[0] * (ax[1]*cx[2] - cx[1]*ax[2])
	    +cx[0] * (ax[1]*bx[2] - bx[1]*ax[2]);
      g[0][0] = ((bx[1]*cx[2]) - (bx[2]*cx[1])) / (bot*ols[3*l+0]);
      g[0][1] = ((bx[2]*cx[0]) - (bx[0]*cx[2])) / (bot*ols[3*l+1]);
      g[0][2] = ((bx[0]*cx[1]) - (bx[1]*cx[0])) / (bot*ols[3*l+2]);
      g[1][0] = ((ax[2]*cx[1]) - (ax[1]*cx[2])) / (bot*ols[3*l+0]);
      g[1][1] = ((ax[0]*cx[2]) - (ax[2]*cx[0])) / (bot*ols[3*l+1]);
      g[1][2] = ((ax[1]*cx[0]) - (ax[0]*cx[1])) / (bot*ols[3*l+2]);
      g[2][0] = ((ax[1]*bx[2]) - (ax[2]*bx[1])) / (bot*ols[3*l+0]);
      g[2][1] = ((ax[2]*bx[0]) - (ax[0]*bx[2])) / (bot*ols[3*l+1]);
      g[2][2] = ((ax[0]*bx[1]) - (ax[1]*bx[0])) / (bot*ols[3*l+2]);
      if (kbug>1)
      {
	fprintf(fpout,"\n gg[][]\n");
	for (j=0; j<3; j++)
	  fprintf(fpout,"     %15.5f %15.5f %15.5f\n",
			 g[j][0],g[j][1],g[j][2]);
      }

      for (i=0; i<3; ++i)            /* Form the elasticity matrix D */
	for (j=0; j<3; dd[i][j++] = 0.0);
      com  = e / (1.0 - vv*vv);
      dd[0][0] = dd[1][1] = com;
      dd[0][1] = dd[1][0] = com*vv;
      dd[2][2] = com * (1.0-vv)/2.0;

      for (j=0; j<3; j++)           /* calculate [D] * [G] (= rint)   */
	for (i=0; i<3; i++)
	{
	  rint[j][i] = 0.0;
	  for (k=0; k<3; k++)
	    rint[j][i] += dd[j][k] * g[k][i];
	}
      if (kbug>1)
      {
	fprintf(fpout,"\n rint[][]\n");
	for (j=0; j<3; j++)
	  fprintf(fpout,"     %15.5f %15.5f %15.5f\n",
			 rint[j][0],rint[j][1],rint[j][2]);
      }

      s =  (dtl[0]+dtl[1]+dtl[2])/2.0; /* Area - using S formula - Zeinc. */
      area = sqrt(s * (s-dtl[0]) * (s-dtl[1]) * (s-dtl[2]));
      at = area * thic;
      for (j=0; j<3; j++)
	for (i=0; i<3; i++)
	{
	  ok[36*l+6*j+i] = 0.0;
	  for (k=0; k<3; k++)
	    ok[36*l+6*j+i] += g[k][j] * rint[k][i] * at;
	}
      if (kbug>0)
      {
	fprintf(fpout,"\n\n Element Stiffness Matrix OK[%4d][][]\n",l+1);
	for (i=0; i<3; i++)
	  fprintf(fpout,"      %15.5f  %15.5f  %15.5f\n",
			 ok[36*l+6*i+0],ok[36*l+6*i+1],ok[36*l+6*i+2]);
      }
    }
}

/* Print deflections */
void print(void)
{
		     /* SUBROUTINE PRINT */

    int    i,l,kd,is,km,nq;
    double  bmt[3],w[6],th;
    char   strfile[20],dffile[20];
    FILE    *fpstr,*fpdfl;

    strcpy(dffile,file);
    strcat(dffile,".dfl");
    fpdfl  = fopen(dffile,"w");
    strcpy(strfile,file);
    strcat(strfile,".str");
    fpstr  = fopen(strfile,"w");

    fprintf(fpout,"\n Nodal Residuals: \n");
    for (i=0; i<nn; ++i)
      fprintf(fpout,"    %5d  %15.5e %15.5e %15.5e\n",
		     i+1,r[ndime*i+0],r[ndime*i+1],r[ndime*i+2]);
    fprintf(fpout,"\n Nodal Deflections: \n");
    for (i=0; i<nn; ++i)
    {
      fprintf(fpout,"    %5d  %15.5e %15.5e %15.5e\n",
		     i+1,cord[ndime*i+0],cord[ndime*i+1],cord[ndime*i+2]);
      fprintf(fpdfl," %5d %15.8e %15.8e %15.8e\n",i+1,
      cord[ndime*i+0]-origcord[ndime*i+0],cord[ndime*i+1]-origcord[ndime*i+1],
      cord[ndime*i+2]-origcord[ndime*i+2]);
    }
    /* Get deflection vector of each triangle and calculate bending */
    /* moments - node destination vector is used here.              */
    fprintf(fpout,"\n Inter-element Moments \n");

    for (l=0; l<ne; ++l) {

      for (kd=0; kd<6; ++kd)
	w[kd]  =  cord[ndime*(nod[6*l+kd]-1)+2] - origcord[ndime*(nod[6*l+kd]-1)+2];

      nq = mbc[4*l+3] - 1;
      th = amat[nq][2]/1000.0;

      for (is=0; is<3; ++is) {
	stress[3*l+is] = 0.0;
	bmt[is]  =  0.0;
	for (kd=0; kd<6; ++kd) {
	  km  =  is*6 + kd;
	  bmt[is] += bm[18*l+km] * w[kd];
	}
	stress[3*l+is] = bmt[is] * 6.0 / (ols[3*l+is] * th*th);  /* = M/Z */
      }

      fprintf(fpout,"   %5d  %15.5f %15.5f %15.5f\n",
		     l+1,bmt[0],bmt[1],bmt[2]);

    }


    pr_cen_stress(stress);

    fprintf(fpout,"\n\n  Inter-element  Stresses\n");
    for (l=0; l<ne; ++l) {
      fprintf(fpout,"   %5d  %15.5e %15.5e %15.5e\n",
		     l+1,stress[3*l+0],stress[3*l+1],stress[3*l+2]);
      fprintf(fpstr,"%5d%15.8f%15.8f%15.8f\n",
	      l+1,stress[3*l+0],stress[3*l+1],stress[3*l+2]);
    }
    fclose(fpdfl);
    fclose(fpstr);
    fprintf(fpout,"\n\n  ****  PROGRAMME TERMINATED PROPERLY  **** \n");
}


/* function calculates the stresses at the centeriod of the element and
   prints to file stress.dat */

void pr_cen_stress(double stress[])
{
FILE *fp0;
register i,j,k,l;
double x,xx,x1,x2,x3,y,yy,y1,y2,y3,z,zz,z1,z2,z3,L,sx,sy,sz;


   if((fp0 = fopen("stress.dat","w")) == (FILE *) NULL)
   {printf("cannot open stress.dat\n"); exit(1);}

   for(i = 0; i < ne; i++)
   {
    sx=0.; sy=0.; sz=0.;
	 for(j = 0; j < 3; j++)
	 {
	 k=j+1; if(k > 2) k=0;  l=k+1; if(l > 2) l=0;
	 x1=cord[ndime*(nod[6*i+k]-1)+0]; x2=cord[ndime*(nod[6*i+l]-1)+0];
	 y1=cord[ndime*(nod[6*i+k]-1)+1]; y2=cord[ndime*(nod[6*i+l]-1)+1];
	 z1=cord[ndime*(nod[6*i+k]-1)+2]; z2=cord[ndime*(nod[6*i+l]-1)+2];
		   x3=cord[ndime*(nod[6*i+j]-1)+0];
		   y3=cord[ndime*(nod[6*i+j]-1)+1];
		   z3=cord[ndime*(nod[6*i+j]-1)+2];

	 x=(y1-y2)*(z3-z2)-(z1-z2)*(y3-y2);/*vector product no. 1*/
	 y=(z1-z2)*(x3-x2)-(x1-x2)*(z3-z2);/*x2,y2,z3 is the pivot node*/
	 z=(x1-x2)*(y3-y2)-(y1-y2)*(x3-x2);/*x1,y1,z1 & x3,y3,z3 are far ends*/
	 x+=x2; y+=y2; z+=z2;

	 xx=(y1-y2)*(z-z2)-(z1-z2)*(y-y2);/*vector product no. 2*/
	 yy=(z1-z2)*(x-x2)-(x1-x2)*(z-z2);/*x2,y2,z2 is the pivot node*/
	 zz=(x1-x2)*(y-y2)-(y1-y2)*(x-x2);/*x1,y1,z1 & x,y,z are far ends*/
	 xx+=x2; yy+=y2; zz+=z2;

	 L=sqrt(pow(x2-xx,2)+pow(y2-yy,2)+pow(z2-zz,2));

	 sx += stress[3*i+j]*(xx-x2)/L;
	 sy += stress[3*i+j]*(yy-y2)/L;
	 sz += stress[3*i+j]*(zz-z2)/L;
	 }
    fprintf(fp0,"%e %e %e\n",sx,sy,sz);
    
   }
   printf("adaptive input file *** stress.dat *** has been generated\n");
fclose(fp0);     
return;
}

    double  area(double, double, double); /* Returns area of l1, l2, l3 */

/*  form R B rotation matrix  */
void rota(void)
{
		     /* SUBROUTINE ROTA */



    int    k,ie,ns,na,nr,n1,n2;
    double  dif,sum,ars,l1,l2,l3;
    double  ssum,area2;
    double  can[3];                  /* moved from common block */

    for (ie = 0;ie < ne; ++ie)
    {
	/* Calculate sidelengths - side no. determined by opposite node */
	for ( na=0; na<3; ++na)
	{   na<=1 ? (n1 = nod[6*ie+(na+1)]) : (n1 = nod[6*ie+(na-2)]);
	    na<=0 ? (n2 = nod[6*ie+(na+2)]) : (n2 = nod[6*ie+(na-1)]);
	    dif = 0.0;
	    for ( k=0; k<3; ++k)
		dif  = dif + (cord[ndime*(n1-1)+k] - cord[ndime*(n2-1)+k])
		       * (cord[ndime*(n1-1)+k] - cord[ndime*(n2-1)+k]);
	    ols[3*ie+na] = sqrt(dif);
	}
	l1  =  ols[3*ie+0];
	l2  =  ols[3*ie+1];
	l3  =  ols[3*ie+2];
	/* Calculate the area of a triangle */
	sum  =  (l1 + l2 + l3)/2.0;
	ars  =  sum * (sum-l1) * (sum-l2) * (sum-l3);
	area2  =  2.0 * sqrt(ars);
	ar2[ie]  =  area2;

	/* Calculate cosines of internal angles */
	ssum  =  l1*l1 + l2*l2 + l3*l3;
	can[0]  =  (ssum - 2.0 * l1*l1)/(2.0 * l2 * l3);
	can[1]  =  (ssum - 2.0 * l2*l2)/(2.0 * l1 * l3);
	can[2]  =  (ssum - 2.0 * l3*l3)/(2.0 * l1 * l2);

	/* Form rotation matrix [1 by 9] for each triangle */
	rbr[9*ie+0]  =       1.0 * l1 / area2;
	rbr[9*ie+1]  =  - can[2] * l2 / area2;
	rbr[9*ie+2]  =  - can[1] * l3 / area2;
	rbr[9*ie+3]  =  - can[2] * l1 / area2;
	rbr[9*ie+4]  =       1.0 * l2 / area2;
	rbr[9*ie+5]  =  - can[0] * l3 / area2;
	rbr[9*ie+6]  =  - can[1] * l1 / area2;
	rbr[9*ie+7]  =  - can[0] * l2 / area2;
	rbr[9*ie+8]  =       1.0 * l3 / area2;

    }

}

/* The function reads in the boundary segments of each sub-domain 
   a pointer vector subdoms is defined which points to the boundary
   segments which are read from the file sub.dat into a two dimnesional
   int array. The number of boundary segments are kept in a vector
   bsgt[]  */

void open_subdomain_file(void)
{
FILE *fsub;
char buf[100];
register i,j;
int dum, bu1, bu2, vali;


   if((fsub = fopen("sub.dat","r")) == (FILE *) NULL)
   {printf("cannot open sub.dat");exit(1);}

   fprintf(fpout,"\n No of sub-domains\n");
   fgets(buf,100,fsub); sscanf(buf,"%d",&t_sds);
   fprintf(fpout,"%5d\n",t_sds);

   if((subdoms=calloc(t_sds+1,sizeof(int)))== NULL)
   {printf("out of core for subdoms\n");exit(1);}

   if((bsgt = calloc(t_sds+1, sizeof(int))) == NULL)
   {printf("out of core for bsgt\n");exit(1);}

   fprintf(fpout,"\n Boundary Segments\n");
   for(i = 0; i < t_sds; i++)
   {
   fgets(buf,100,fsub); sscanf(buf,"%d",&bu1);
   bsgt[i] = bu1;
   fprintf(fpout,"%5d\n",bsgt[i]);

   if((subdoms[i]=calloc(bsgt[i]*2+1,sizeof(int *)))
   ==(int *) NULL)
   {printf("out of core for subdoms[]\n");exit(1);}

      for(j = 0; j < bsgt[i]; j++)
      {
      fgets(buf,100,fsub); 
      sscanf(buf,"%d %d %d",&dum, &bu1, &bu2);
      vali = subdoms[i][2*j+0] = bu1; 
      vali = subdoms[i][2*j+1] = bu2;
      fprintf(fpout,"%5d %5d %5d\n",j+1,subdoms[i][2*j+0],subdoms[i][2*j+1]);
      }
   }
fclose(fsub);
return;
}

/* Set residuals to zero and add applied loads */
void load(void)
{
		     /* SUBROUTINE LOAD */
    int    n,k,j,kbug,ndim;

    kbug  =  0;
/*
    if (kbug > 0)
      write(fpout,"\n **********  SUBROUTINE LOAD  **************\n");
*/
    for (n=0; n<nn; ++n)
      for (k=0; k<ndime; r[ndime*n+k++] = 0.0);  /* Initialise r[ndime*nn+ndime] */

    if (iln > 0) {
      for (j=0; j<iln; ++j) {
	n  =  nc[j]-1;
	for (k=0; k<ndime; ++k)
	  r[ndime*n+k] += aload[j][k];
      }
      if (kbug > 0) {

	fprintf(fpout,"\n Node                 Residuals \n");
	for (n=0; n<nn; ++n)
	  fprintf(fpout," %5d     %12.5f %12.5f %12.5f\n",
			 n+1,r[ndime*n+0],r[ndime*n+1],r[ndime*n+2]);

      }
    }
}


#if ALT
/* alternate loading */
void alt_load(void)
{     
			memmove(OUT.cord, cord,sizeof(double)*nn*ndime);
			memmove(OUT.bb, bb,sizeof(double)*nn*ndime);
			memmove(OUT.r, r,sizeof(double)*nn*ndime);
			memmove(OUT.v, v,sizeof(double)*nn*ndime);
			memmove(OUT.ocord, ocord,sizeof(double)*nn*ndime);
			memmove(OUT.origcord, origcord,sizeof(double)*nn*ndime);
			memmove(OUT.aload, aload,sizeof(double)*iln*5);
			memmove(OUT.nc, nc,sizeof(int)*iln);
			memmove(OUT.nod, nod,sizeof(int)*ne*6);
			memmove(OUT.ols, ols,sizeof(double)*ne*3);

return;
}       


void alt_unload()
{     
			memmove(cord, OUT.cord,sizeof(double)*nn*ndime);
			memmove(bb, OUT.bb,sizeof(double)*nn*ndime);
			memmove(r, OUT.r,sizeof(double)*nn*ndime);
			memmove(v, OUT.v,sizeof(double)*nn*ndime);
			memmove(ocord, OUT.ocord,sizeof(double)*nn*ndime);
			memmove(origcord, OUT.origcord,sizeof(double)*nn*ndime);
			memmove(aload, OUT.aload,sizeof(double)*iln*5);
			memmove(nc, OUT.nc,sizeof(int)*iln);
			memmove(nod, OUT.nod,sizeof(int)*ne*6);
			memmove(ols, OUT.ols,sizeof(double)*ne*3);
			
return;
}                       
#endif

/*  read data from file  */
void data(void)
{
		     /*  DATA INPUT ROUTINE   */


    FILE    *fpin;
    int     i,n,k,lnc,node;
    char    line[100],infile[20];
    strcpy(infile,file);
    strcat(infile,".dat");
    fpin  = fopen(infile,"r");
    strcpy(outfile,file);
    strcat(outfile,".out");
    fpout = fopen(outfile,"w");

    fgets  (titel,50,fpin);
    fputs(titel,stdout);
    fprintf(fpout,"\n\n%50s",titel);

    fprintf(fpout,"\n\n         DATA AND RESULTS   \n");

    fgets(line,100,fpin);
    fputs(line,stdout);
    sscanf (line,"%10lf%10lf%10lf", &dt, &damp, &ff);
    if (ff == 0.0)   ff = 1.0;
    fprintf(fpout,"\n  dt = %10.5f,   damp = %10.5f,   ff = %10.5f\n",
		   dt, damp, ff);

    /* ------- Parameters --------- */
    fgets(line,100,fpin);
    sscanf(line,"%d%d%d%d%d%d%d%d%d%d%d\n",
		  &nn, &ne, &nb, &nm, &nl, &ndime,
		  &nstr, &nbe, &kmax, &nmax, &iln);
    fprintf(fpout,"\n No of Nodes                      (nn) =%5d",nn);
    fprintf(fpout,"\n No of Elements                   (ne) =%5d",ne);
    fprintf(fpout,"\n No of Boundary Conditions        (nb) =%5d",nb);
    fprintf(fpout,"\n No of Material Types             (nm) =%5d",nm);
    fprintf(fpout,"\n No of Links                      (nl) =%5d",nl);
    fprintf(fpout,"\n No of Dimensions              (ndime) =%5d",ndime);
    fprintf(fpout,"\n No of Geodesic Strings         (nstr) =%5d",nstr);
    fprintf(fpout,"\n No of Beam Elements             (nbe) =%5d",nbe);
    fprintf(fpout,"\n Max no of Iteration Groups     (kmax) =%5d",kmax);
    fprintf(fpout,"\n Max no of Iterations per Group (nmax) =%5d",nmax);
    fprintf(fpout,"\n No of Applied Loads             (iln) =%5d\n",iln);


    if((nod=calloc(ne*6+1,sizeof(int))) == NULL)
    {printf("out of core for nod\n");exit(1);}

    if((cord=calloc(nn*ndime+1,sizeof(double))) == NULL)
    {printf("out of core for cord\n");exit(1);}

    if((origcord=calloc(nn*ndime+1,sizeof(double))) == NULL)
    {printf("out of core for origcord\n");exit(1);}

    if((r=calloc(nn*ndime+1,sizeof(double))) == NULL)
    {printf("out of core for r\n");exit(1);}

    if((v=calloc(nn*ndime+1,sizeof(double))) == NULL)
    {printf("out of core for v\n");exit(1);}

    if((bb=calloc(nn*ndime+1,sizeof(double))) == NULL)
    {printf("out of core for bb\n");exit(1);}

    if((ok=calloc(ne*6*6+1,sizeof(double))) == NULL)
    {printf("out of core for cord\n");exit(1);}

    if((ols=calloc(ne*3+1,sizeof(double))) == NULL)
    {printf("out of core for ols\n");exit(1);}

    if((mbc=calloc(ne*4+1,sizeof(int))) == NULL)
    {printf("out of core for mbc\n");exit(1);}

    if((ar2=calloc(ne+1,sizeof(double))) == NULL)
    {printf("out of core for ar2\n");exit(1);}


    if((bm=calloc(ne*18+1,sizeof(double))) == NULL)
    {printf("out of core for bm\n");exit(1);}

    if((rbr=calloc(ne*9+1,sizeof(double))) == NULL)
    {printf("out of core for rbr\n");exit(1);}

    if((rlen = calloc(ne+1, sizeof(double))) == NULL)
    {printf(" out of core for rlen\n"); exit(1);}

    if((ocord = calloc(nn*ndime+1, sizeof(double))) == NULL)
    {printf(" out of core for ocord\n"); exit(1);}

    fgets(line,100,fpin);

    /* ------- Coordinates ------------- */
    fprintf(fpout,"\n Nodal Coordinates: \n\n",
		  "   Node                 Coordinates \n");
    for (i = 0; i < nn; i++) {
	fgets  (line, 60, fpin);
	sscanf (line,"%5d",&n);
	node = n-1;
	sscanf (line,"%5d%15lf%15lf%15lf", &n,
		&cord[ndime*node+0], &cord[ndime*node+1], &cord[ndime*node+2]);
	fprintf(fpout,"%5d %20.5f %12.5f %12.5f\n", n,
		cord[ndime*node+0], cord[ndime*node+1], cord[ndime*node+2]);
	for (k=0; k<ndime;k++) 
	origcord[ndime*node+k] = cord[ndime*node+k];
    }


    /* ---------- Element Topology --------- */
    if (ne > 0) {
	fprintf(fpout,"\n Element Topology: \n\n",
		  " Element                 Topology \n");
	for (i = 0; i < ne; i++) {
	    fgets  (line, 80, fpin);
	    sscanf (line,"%5d",&n);
	    sscanf (line,"%5d%5d%5d%5d%5d", &lnc,
		&nod[6*i+0], &nod[6*i+1], &nod[6*i+2], &mbc[4*i+3]);
	    fprintf(fpout,"%5d %25d %10d %10d %10d\n",i+1,
		nod[6*i+0], nod[6*i+1], nod[6*i+2],mbc[4*i+3]);
	}
    }
    if (nl > 0) {
	fprintf(fpout,"\n Link Topology: \n\n",
		  " Link                    Topology \n");
	for (i = 0; i < ne; i++) {
	    fgets  (line, 80, fpin);
	    sscanf (line,"%5d",&n);
	    sscanf (line,"%5d%5d%5d%5d", &n,
		&nodl[n-1][0], &nodl[n-1][1], &nodl[n-1][2]);
	    fprintf(fpout,"%5d %25d %10d %10d\n",n,
		nodl[n-1][0], nodl[n-1][1], nodl[n-1][2]);
	}
    }

    /* ---------- Material Properties ------------- */
    for (i = 0; i < nm; i++) {
	fprintf(fpout,"\n Material Properties: \n\n",
	      " Mat No.              Properties \n");
	fgets  (line, 100, fpin);
	sscanf (line,"%5d",&n);
	sscanf (line,"%5d%5d%lf%lf%lf%lf%lf", &n,
	      &mat[n-1],&amat[n-1][1],&amat[n-1][0],&amat[n-1][2],
	      &amat[n-1][3],&amat[n-1][4]);
	fprintf(fpout,"%5d %5d %12.4e %12.4e %12.4e %12.4e %12.4e\n",
		n, mat[n-1], amat[n-1][0],
		amat[n-1][1], amat[n-1][2], amat[n-1][3], amat[n-1][4]);
    }

    /* ---------- Boundary Conditions --------------- */
    fprintf(fpout,"\n Boundary Conditions: \n\n",
	      " Node                 Restraints \n");
    for (i = 0; i < nb; i++) {
	fgets  (line, 50, fpin);
	sscanf (line,"%5d%5d%5d%5d", &nco[i][0], &nco[i][1], &nco[i][2],
		  &nco[i][3]);
	fprintf(fpout,"%5d %10d %5d %5d\n", nco[i][0], nco[i][1], nco[i][2],
		   nco[i][3]);
    }


    /* ----------- Applied Loads ------------------ */
    /* NB. Last line for last node, even if no load is applied there */
    if (iln > 0)
    {   fprintf(fpout,"\n Loading Conditions: \n\n",
		  " Node No.            Loading \n");
	iln = -1;
	do
	{   ++iln;
	    fgets  (line, 100, fpin);
	    sscanf (line,"%d%lf%lf%lf", &nc[iln],
		&aload[iln][0], &aload[iln][1], &aload[iln][2]);
	    fprintf(fpout," %5d %15.5f %12.5f %12.5f\n",
		nc[iln], aload[iln][0], aload[iln][1], aload[iln][2]);
	}  while(nc[iln] < nn);
	++iln;
    }
    else
	fprintf(fpout, "\n There are no applied loads. \n\n");

	adjel1();     /*      Set up an array of adjacent elements */
	bound();      /* Incorporate side conditions at boundaries */

}

/* Set up an array of elements adjacent to each element */
void adjel1(void)
{

    int     l,kbug,nss,n1,n2,la,n,naa,nbb,i;


    kbug  =  0;
    if (kbug > 0)
	fprintf(fpout, "\n ********  SUBROUTINE ADJEL1  *******\n");

    for ( l=0; l<ne; ++l)
	for ( nss=0; nss<3; ++nss)           /* for each side of 'l' */
	{   nss<2 ? (n1 = nod[6*l+(nss+1)]) : (n1 = nod[6*l+(nss-2)]);
	    nss<1 ? (n2 = nod[6*l+(nss+2)]) : (n2 = nod[6*l+(nss-1)]);
	    if (kbug > 2)
		fprintf(fpout, "\n N1 = %5d,  N2 = %5d\n", n1,n2);
	    mbc[4*l+nss] = 0;
	    for ( la=0; la<ne; ++la)
		if ( la != l)
		    for ( n=0; n<3; ++n)     /* for each node of 'la' */
		    {   naa = nod[6*la+n];
			if ( naa == n1)
			    for ( i=0; i<3; ++i)
			    {   nbb = nod[6*la+i];
				if ( nbb == n2 )
				    mbc[4*l+nss] = la+1;
			    }
		    }
	}
}



/* Modify matrix mbc[element][side] to allow for boundary conditions */
void bound(void)
{

    int     l,kbug,nss,n1,n2,r1,r2,la,n,naa,nbb,i,ib,iib;


    kbug  =  0;
    if (kbug > 0)
      fprintf(fpout, "\n ********  SUBROUTINE BOUND  *******\n");


    for ( l=0; l<ne; ++l)
      for ( nss=0; nss<3; ++nss)
	if (mbc[4*l+nss] == 0)
	{
	  mbc[4*l+nss] = -111;                 /*  Free Edge  */
	  nss<2 ? (n1 = nod[6*l+(nss+1)]) : (n1 = nod[6*l+(nss-2)]);
	  nss<1 ? (n2 = nod[6*l+(nss+2)]) : (n2 = nod[6*l+(nss-1)]);
	  if (kbug > 2)
	    fprintf(fpout, "\n N1 = %5d,  N2 = %5d\n", n1,n2);
	  for ( ib=0; ib<nb; ++ib)
	    if (n1 == nco[ib][0])
	    {
	      for ( iib=0; iib<nb; ++iib)
		if (n2 == nco[iib][0])
		{
		  r1 = nco[ib][1];
		  r2 = nco[iib][1];
		  if ((r1>9) && (r2>9))
		  {
		    int rc1 = nco[ib][3];
		    int rc2 = nco[iib][3];
		    if ((rc1>0) && (rc2>0))
		      mbc[4*l+nss] = -200;       /*  Clamped  */
		    else
		      mbc[4*l+nss] = -222;       /*  Symmetrical  */
		  }
		  else
		    mbc[4*l+nss] = -100;         /*  Simple Support */
		}
	    }
	}

    /*  Print Results */
    for ( l=0; l<ne; ++l)
    {
      fprintf(fpout,"\n Element =%4d   Node1 =%4d   Node2 =%4d",
		     l+1,nod[6*l+0],nod[6*l+1]);
      fprintf(fpout,"   Node3 =%4d    Mat No =%4d\n",
		     nod[6*l+2],mbc[4*l+3]);
      fprintf(fpout,"   Side Cond1 =%5d   Side Cond2 =%5d   Side Cond3 =%5d\n",
		     mbc[4*l+0],mbc[4*l+1],mbc[4*l+2]);
    }
}



   
void elemcord(int n,int nn[], double x[], double y[])
{
int vali;

   vali = nn[0] = nod[6*n+0];
   vali = nn[1] = nod[6*n+1];
   vali = nn[2] = nod[6*n+2];

   nodecord(nn[0],&x[0], &y[0]);
   nodecord(nn[1],&x[1], &y[1]);
   nodecord(nn[2],&x[2], &y[2]);
return;
}

void nodecord(int node, double *px, double *py)
{
double val;

val =    *px = origcord[ndime*(node-1)+0];
val =    *py = origcord[ndime*(node-1)+1];
return;
}



void routput(void)
{
int i,j,k,n;
double tL[3],rL;
FILE *fp0;

   if((fp0 = fopen("out.dat","w")) == (FILE *) NULL)
   {printf("cannot open out.dat\n"); exit(1);}

   fprintf(fp0,"%s", titel);

   fprintf(fp0,"%10.5f%10.5f%10.5f\n", dt, damp, ff);

   fprintf(fp0,"%5d%5d%5d%5d%5d%5d%5d%5d%5d%5d%5d\n",nn,ne,nb,nm,nl,
   ndime, nstr, nbe, kmax,nmax, iln);

   fprintf(fp0,"%5d\n",nq);


   for(i = 0; i < nn; i++)
   {
   fprintf(fp0,"%5d%15.5f%15.5f%15.5f\n",i+1, cord[ndime*i+0], cord[ndime*i+1],
   cord[ndime*i+2]);
   }



   if(ne > 0)
   {
      for(i = 0; i < ne; i++)
      {
      fprintf(fp0,"%5d%5d%5d%5d%5d\n",i+1,
      nod[6*i+0],nod[6*i+1],nod[6*i+2],nod[6*i+3]);
      }
   }



   if(nl > 0)
   {
      for(i = 0; i < nl;i++)
      {
      fprintf(fp0,"%5d%5d%5d%5d%15.8f\n",i+1,nodl[i][0],nodl[i][1],
      nodl[i][2],rL);
      }
   }



   for(i = 0; i < nm; i++)
   {
   fprintf(fp0,"%5d%5d%12.5e%12.5e%12.5e%12.5e%12.5e\n",i+1,mat[i],amat[i][0],
   amat[i][1],amat[i][2],amat[i][3],amat[i][4]);
   }



   for(i = 0; i < nb; i++)
   {
   fprintf(fp0,"%5d%5d%5d%5d\n",nco[i][0],nco[i][1],nco[i][2],nco[i][3]);
   }



   if(iln > 0)
   {
   iln = 0;
more:
   iln++;
   i = iln - 1;

   fprintf(fp0,"%5d%15.5f%15.5f%15.5f\n",nc[i],aload[i][0],aload[i][1],
   aload[i][2]);

   if(nc[i] < nn)
   goto more;
   }


return;
}
