						 /* CKWS272.CFG */
#define GEOM       1   /*[1] ok updated after each peak */
#define DR_INT     1   /*[1] DR integration scheme active */
#define ITERATIONS 100
#define    T800    1

#include   <stdlib.h>

#if     T800
#include   <chan.h>
#endif

#include   <math.h>
#include   <timer.h>

#define    TICK    15625

#define    NODES     300
#define    ELEMS     500

#define    ML      5
#define    MM      2
#define    MB     20
#define    MDIME   3
#define    MLN    10
#define    XX
#define      TOL_E 10.e-20

#define    MAX_BYTE 9999




struct rec{ int nn_g;

int    nn, ne, nb, nm, nl, ndime, kt, nt, nstr, nbe, kmax, nmax, iln, 
			 it, mat[MM], nc[MLN], nod[6*ELEMS];

int    no_of_sds,t_sds, nn_sd, ne_sd, bsgt, b_nodes;

int    N[NODES],E[ELEMS],mark[NODES*4];/*for local to global numberings */

float  t_calc, t_res, t_eng;

double dt, damp, af, b, eng, engl, aload[MLN][MDIME], amat[MM][5], 
	   cord[3*NODES],bb[3*NODES],ols[3*ELEMS],
	   r[3*NODES],v[3*NODES]
	   , ocord[3*NODES], origcord[3*NODES];
} IN;


struct rec2{int it, peak; double eng;} IN2;

struct rec3{int sub_domain; double eng;} IN3;/*for sending eng*/

struct rec4{double resid[MDIME];} IN4; /*for exchanging residuals*/

struct rec5{double resid[MDIME];} IN5; /*for exchanging residuals*/

XX int  nn_g, *NNG;

XX int       nn, ne, nb, nm, nl, ndime, kt, nt, nstr, nbe, kmax, nmax, iln;
XX int       it;
XX int       no_of_sds, t_sds, nn_sd, ne_sd, bsgt, b_nodes;
XX double    dt, damp, af, b, eng, engl, *vec, ok_p[36*ELEMS];
XX int       idno;

    void  load_p(void);
    void  init_p(void);
    void  resi1_p(void);
    void  presi_p(void);
    void  ptriang_p(void);
    void  n1n2_p(int, int, int *, int *);
    void  sidelen_p(int,int,int,double [3], double [3][3]);
    void  plinks_p(void);
    double  step_p(double eng_g);
    void  peak_p(void);
    int   un_pack_IN(void);
	void  load_IN2(int it, int peak);
    void pform_p(void);


#if T800
    void first_itr_display(void);
    void  exchange_bound_node_residuals(void);
    double receive_send_1(double eng_g);
    double receive_send_2(double eng_g);
    void b_ex_0(int i, int msglen, int max);
    void b_ex_1(int i, int msglen, int max, int min, int prev_ii);
    void b_ex_2(int i, int msglen, int max, int min, int prev_ii);
    void sync(void);
    void e_chan_out_Buffer (void *, int, CHAN *);
    void e_chan_in_Buffer (void *, CHAN *);
    void receive_signal(void);


CHAN **in_p, **out_p;

double check[3*NODES];


/* Main integration scheme for the sub-domain*/
main(argc, argv, envp, in_ports, ins, out_ports, outs)

int argc, ins, outs;
char *argv[], *envp[];
CHAN *in_ports[], *out_ports[];

#endif
{
register i,j;
int  msglen, test, peak, vali, ch_no;
int dummy;
int after_iteration_break = 0, fst = 0;
double val, eng_g;
long tc1,tc2, tr,te, t1,t2, t3,t4;
float t_t;


     idno = (int) in_ports[10];

     tc2 = 0;
     tr  = 0;                           /*cummulative timers to zero */
     te  = 0;

     

#if T800
    in_p = in_ports;
    out_p = out_ports;
    msglen = sizeof(IN);
    alt_wait(1, in_p[idno]);

   /* message from ROOT */

    e_chan_in_Buffer( &IN, in_p[idno]);

/*
    chan_in_word(&msglen, in_p[idno]);              
    chan_in_message(msglen, &IN,in_p[idno]);
*/
#endif
    
    un_pack_IN();

    pform_p();                                  /* form ok matrix */

    first_itr_display();                            /* REFLECT data to ROOT */
    sync();             /* all workers wait here */

for (kt=0; kt<kmax; ++kt)
{
    for (nt=0; nt<nmax; ++nt) 
    {

    tc1 = timer_now();

    it = kt*nmax + nt+1;
#if T800


    if(after_iteration_break == 1 || it == nmax*kmax)
    {
      peak = -1;                /* held to -1 showing converg or comp its*/
      load_IN2(it, peak);
      msglen = sizeof(IN2);

      e_chan_out_Buffer (&IN2, msglen, out_p[idno]);

/*
      chan_out_word(msglen, out_p[idno]);
      chan_out_message(msglen, &IN2, out_p[idno]);
*/
      goto results;
    }
    else
	    if (fmod(it,ITERATIONS) == 0 && no_of_sds == 1) 
      {
        peak = 0;                    /*held to zero if no peak or  converg*/
        load_IN2(it, peak);
    	  msglen = sizeof(IN2);

        e_chan_out_Buffer(&IN2, msglen, out_p[idno]);
/*
        chan_out_word(msglen, out_p[idno]);
        chan_out_message(msglen, &IN2, out_p[idno]);
*/
  	  }
#endif

	load_p();                                  /* add applied loads   */

	resi1_p();

	t1 = timer_now();
    memcpy(check,&(IN.r[0]), sizeof(double)*ndime*nn);
    exchange_bound_node_residuals();
    memcpy(check,&(IN.r[0]), sizeof(double)*ndime*nn);
	t2 = timer_now();

	eng_g = step_p(eng_g);                     /* main iteration step */

	t3 = timer_now();
	eng_g = receive_send_1(eng_g);                         /* receive at task 1 or send energies to the task 1*/
	eng_g = receive_send_2(eng_g);                         /*task 1 sends total energy to other tasks */
	t4 = timer_now();

	if (damp < 0.00001) 
	{
	  if (eng < TOL_E)
	  after_iteration_break = 1;else after_iteration_break = 0;
	   if (eng < engl)
	   {
#if T800
	   if(no_of_sds == 1)
	   {
	   peak = 1;                            /* Equal 1 if peak is found */
	   load_IN2(it, peak);
	   msglen = sizeof(IN2);

     e_chan_out_Buffer (&IN2, msglen, out_p[idno]);
/*
     chan_out_word(msglen,out_p[idno]);
     chan_out_message(msglen, &IN2, out_p[idno]);
*/
	   }
#endif
	   peak_p();
	   }
	 engl = eng;
	}
    /****************** 1st  iteration *******************/
   tc2 += (timer_now() - tc1);
   tr  += t2 -t1;
   te  += t4-t3;


   }
}

results:

	IN.t_res = (float) tr/TICK/60.;
	IN.t_eng = (float) te/TICK/60.;
	IN.t_calc = ((float) tc2)/TICK/60. - IN.t_res - IN.t_eng;

#if T800

/*
    sync();
*/

    receive_signal();


    msglen = sizeof(IN);

    e_chan_out_Buffer( &IN, msglen, out_p[idno]);

/*
    chan_out_word(msglen, out_p[idno]);
    chan_out_message(msglen, &IN, out_p[idno]);
*/


#endif

}


/* -------------------------------------------------------------------------*/

void e_chan_out_Buffer (pointer, hossz, channel)
char *pointer;
CHAN *channel;
int hossz;
{
  int db, maradek, k_hossz, i;
  char tmp;


  db = hossz / MAX_BYTE;
  maradek = hossz % MAX_BYTE;
  for (i = 0; i <= db; i++)
  {

    k_hossz = (i == db ? maradek : MAX_BYTE );
    tmp = *(pointer+k_hossz);
    *(pointer+k_hossz) = (i == db ? 0 : 1 );
    chan_out_word (k_hossz+1, channel);
    chan_out_message(k_hossz+1, pointer, channel);
    *(pointer+k_hossz) = tmp;
    pointer += MAX_BYTE;
  }
}

void e_chan_in_Buffer (pointer, channel)
char *pointer;
CHAN *channel;
{
  int i, r_hossz;
  char tmp;

  do
  {
    chan_in_word(&r_hossz, channel);
    tmp = *(pointer+r_hossz-1);
    chan_in_message(r_hossz, pointer, channel);
    pointer += MAX_BYTE;
  }
  while ( *(pointer-MAX_BYTE+r_hossz-1) );
  *(pointer-MAX_BYTE+r_hossz-1) = tmp;
}

/* -------------------------------------------------------------------------*/


/* Set residuals to zero and add applied loads */
void load_p(void)
{
		     /* SUBROUTINE LOAD */
    int    n,k,j,kbug,ndim;

    kbug  =  0;
/*
    if (kbug > 0)
      write(fpout,"\n **********  SUBROUTINE LOAD  **************\n");
*/
    for (n=0; n<nn; ++n)
      for (k=0; k<ndime; IN.r[ndime*n+k++] = 0.0);  /* Initialise r[nn][ndime] */

    if (iln > 0) {
      for (j=0; j<iln; ++j) {
	n  =  IN.nc[j]-1;
	for (k=0; k<ndime; ++k)
	  IN.r[ndime*n+k] += IN.aload[j][k];
      }
    }
}

/* Calculate Residuals */
void resi1_p(void)
{

    presi_p();                /* Calculate in-plane residuals            */

}

/* Calculate Residuals */
void presi_p(void)
{
    int    i;

    if (ne > 0)
      ptriang_p();

}


/* Residuals for triangles */
void ptriang_p(void)
{
    int l,mt,n1,n2,n3,nlt,i,ns,k,ii,j;
		double  dtl[3],dtt[3][3],dr,extension,tension,val;

for (l=0; l<ne; l++)
{
			mt = 0;                 /*IN.mbc[l] - 1;*/ /* fourth column */
			nlt = IN.mat[mt] - 1;
			n1 = IN.nod[6*l+0] - 1;
			n2 = IN.nod[6*l+1] - 1;
			n3 = IN.nod[6*l+2] - 1;
			sidelen_p(n1,n2,n3,dtl,dtt);

      if (nlt == 2)                         /* Membrane of fixed tension  */
      {
	/* This is unlikely to be required for R/C elements and is  */
	/* therefore not included at present                        */
   }
   else
   {
	for (ns=0; ns<3; ns++)
	{
	  tension = 0.0;
		for (ii=0; ii < 3; ii++)
	    {
			extension = dtl[ii] - IN.ols[3*l+ii];
			val = ok_p[36*l + 6*ns + ii];
			tension += ok_p[36*l+6*ns+ii] * extension;
		}
		n1n2_p(l,ns,&n1,&n2);              /* nodes n1, n2 at ends of ns  */
		for (k=0; k<ndime; k++)
		{
			val = dtt[ns][k];
			dr = dtt[ns][k] * tension/dtl[ns];
			val = IN.r[ndime*n1+k] += dr;
			val = IN.r[ndime*n2+k] -= dr;
	    }
	}
   }
}

}


void n1n2_p(int l, int node, int *n1, int *n2)
{

    int e1,e2;

    switch (node)
    {
      case 0:
	*n1 = IN.nod[6*l+1] - 1;
	*n2 = IN.nod[6*l+2] - 1;
	break;
      case 1:
	*n1 = IN.nod[6*l+2] - 1;
	*n2 = IN.nod[6*l+0] - 1;
	break;
      case 2:
	*n1 = IN.nod[6*l+0] - 1;
	*n2 = IN.nod[6*l+1] - 1;
	break;
      default:
	break;
    }
}


/* Main Iteration Step */
double  step_p(double eng_g)
{
    register i;
    int    n,k;
    double  pcord,vel, val;

    eng = 0.;
    eng_g = 0.;

   for (n=0; n<nn; ++n)
   {
    for (k=0; k<ndime; ++k) {
      pcord = IN.ocord[ndime*n+k];
	  val = IN.ocord[ndime*n+k] = IN.cord[ndime*n+k];
#if DR_INT
	  vel = IN.v[ndime*n+k] = IN.v[ndime*n+k]*af +
			IN.r[ndime*n+k]*dt*b/IN.bb[ndime*n+k];
	  if (fabs(vel) < TOL_E)
	  IN.v[ndime*n+k] = 0.0;
	  IN.cord[ndime*n+k] += dt*IN.v[ndime*n+k];
#else
	  val = IN.cord[ndime*n+k] = b * dt*dt * IN.r[ndime*n+k]/IN.bb[ndime*n+k] 
						 - af * pcord + 2 * b * IN.ocord[ndime*n+k];
	  vel = IN.v[ndime*n+k] = (IN.cord[ndime*n+k] - pcord) / (2*dt);
	  if (fabs(vel) < TOL_E)
	  IN.v[ndime*n+k] = 0.0;
#endif
      if(n < b_nodes)
	  eng += (vel*vel * IN.bb[ndime*n+k])/vec[n];
      else
	  eng += vel*vel * IN.bb[ndime*n+k];
	}    /* k < ndime loop end */
  }     /*  n < nn    loop end */

return(eng_g = eng);
}

/* Perform Kinetic Damping at Energy Peak */
void  peak_p(void)
{
    int    n,k;
    double  dash;

    eng = 0.0;

    for (n=0; n<nn; ++n)
      for (k=0; k<ndime; ++k) {
	dash = IN.bb[ndime*n+k];
	IN.cord[ndime*n+k] += -1.* IN.v[ndime*n+k]*dt*1.5 + (dt*dt*IN.r[ndime*n+k])/(2.0*dash);
    }


	load_p();
#if GEOM
	pform_p();
#endif
    resi1_p();
    exchange_bound_node_residuals();
    init_p();
}

/* Initial iteration step */
void init_p()
{
    int      in,idime;
    double    dby2;

    dby2  =  damp/2.0;
    af = (1.0-dby2) / (1.0+dby2);
    b  = 1.0 / (1.0+dby2);
    for (in=0; in<nn; ++in) {
      for (idime=0; idime<ndime; ++idime) {
	IN.ocord[ndime*in+idime] = IN.cord[ndime*in+idime];
	IN.cord[ndime*in+idime] += (dt*dt * IN.r[ndime*in+idime]) / 
    (2.0*IN.bb[ndime*in+idime]);
	IN.v[ndime*in+idime] = 0.0;
      }
    }
}

/* Calculate sidelengths of element n1,n2,n3 */
void sidelen_p(int n1,int n2,int n3,double slen[3],double templ[3][3])
{
    int    i,idime;
    double  tl;

    for (i=0; i<3; slen[i++] = 0.0);

    for (idime=0; idime<ndime; ++idime)
    {
      templ[0][idime] = IN.cord[ndime*n3+idime] - IN.cord[ndime*n2+idime];
      templ[1][idime] = IN.cord[ndime*n1+idime] - IN.cord[ndime*n3+idime];
      templ[2][idime] = IN.cord[ndime*n2+idime] - IN.cord[ndime*n1+idime];
    }
    for (i=0; i<3; ++i)
    {
      tl = 0.0;
      for (idime=0; idime<ndime; ++idime)
	tl  +=  templ[i][idime] * templ[i][idime];
      slen[i]  =  sqrt(tl);
    }
}


/* function un-packs the stucture received in IN */

int un_pack_IN(void)
{

    nn_g = IN.nn_g;

    nn=IN.nn; ne=IN.ne; nb=IN.nb; nm=IN.nm; nl=IN.nl; 

    ndime=IN.ndime; kt=IN.kt; nt=IN.nt; nstr=IN.nstr; 

    nbe=IN.nbe; kmax=IN.kmax; nmax=IN.nmax; iln=IN.iln; 

    it=IN.it;  

    dt=IN.dt; damp=IN.damp; af=IN.af; b=IN.b; eng=IN.eng; 

    engl=IN.engl;

    no_of_sds=IN.no_of_sds; nn_sd=IN.nn_sd; ne_sd=IN.ne_sd;

		bsgt=IN.bsgt; b_nodes = IN.b_nodes;  

		t_sds = IN.t_sds;

   vec = calloc(b_nodes, sizeof(double));
return(0);
}





void first_itr_display(void)
{
int msglen, root,north,south,control,no;

    msglen = sizeof(IN);

    e_chan_out_Buffer( &IN, msglen, out_p[idno]);

/*
    chan_out_word(msglen,out_p[idno]);
    chan_out_message(msglen, &IN, out_p[idno]);
*/

return;
}


void load_IN2(int it, int peak)
{
      IN2.it = it; 
      IN2.peak = peak;
      IN2.eng = eng;
}





/* function to exchange the boundary node residuals this function is
called after each residual calculation.  The worker task has 3 channels
0, 1 and 2,  ch_no 0 is connected to the router, ch_no 1 to the upper task
and ch_no 2 to the lower task */

void exchange_bound_node_residuals(void)
{
int i,ii,other_sds,msglen,ch_no,max,min,prev_ii, destination;

msglen = sizeof(IN4);    /* this is common */

for(i = 0 ; i < b_nodes; i++)
{

  max = no_of_sds;   min = no_of_sds;  prev_ii = 0;
  for(ii = 0; (other_sds=IN.mark[4*i+ii]) != 0; ii++) /* scan for the adjacent upper or lower sub-domain */
  {
  max = (max > other_sds) ? max : other_sds;
  min = (min < other_sds) ? min : other_sds;
  if(no_of_sds > other_sds) prev_ii = ii;/* a value of one step less sd */
  }

   vec[i] = (double)ii + 1.0 ;                 /* For K.E. calculations */
   switch(ii)
   {
   case 1:
   b_ex_0(i, msglen, max);     /* boundary node in only two subdomains */
   break;

   default:
   b_ex_1(i, msglen, max, min, prev_ii);
   b_ex_2(i, msglen, max, min, prev_ii);
   break;
   }
}

}

void b_ex_0(int i, int msglen, int max)
{
register j;
int vali, destination;


memcpy(IN4.resid, &(IN.r[ndime*i+0]), sizeof(double)*ndime);

destination = IN.mark[4*i+0]-1;                    /* 1st entry in mark */

if(idno == max-1) {
alt_wait(1,in_p[destination]);

e_chan_in_Buffer(&IN5, in_p[destination]);

/*
chan_in_word(&msglen, in_p[destination]);
chan_in_message(msglen, &IN5, in_p[destination]);
*/

e_chan_out_Buffer(&IN4, msglen, out_p[destination]);

/*
chan_out_word(msglen, out_p[destination]);
chan_out_message(msglen, &IN4, out_p[destination]);
*/

for(j = 0; j < 3; j++) IN.r[ndime*i+j] += IN5.resid[j];  /* add to residual */
}
else
{

e_chan_out_Buffer(&IN4, msglen, out_p[destination]);

/*
chan_out_word(msglen, out_p[destination]);
chan_out_message(msglen, &IN4, out_p[destination]);
*/

alt_wait(1,in_p[destination]);

e_chan_in_Buffer(&IN5, in_p[destination]);

/*
chan_in_word(&msglen, in_p[destination]);
chan_in_message(msglen, &IN5, in_p[destination]);
*/
for(j = 0; j < 3; j++) IN.r[ndime*i+j] += IN5.resid[j];  /* add to residual */
}

}



void b_ex_1(int i, int msglen, int max, int min, int prev_ii)
{
int ii,j, vali, destination;
double  val;

if(idno == min-1) /*send*/
{
   destination = IN.mark[4*i+0]-1;/*to 1st entry in mark */
   memcpy(IN4.resid, &(IN.r[ndime*i+0]), sizeof(double)*ndime);

   e_chan_out_Buffer (&IN4, msglen, out_p[destination]);

/*
   chan_out_word(msglen,out_p[destination]);
   chan_out_message(msglen,&IN4, out_p[destination]);
*/
}
else
{
   destination = IN.mark[4*i+prev_ii]-1;     /*from prev */
   alt_wait(1, in_p[destination]);  /* from previous subdomain */

   e_chan_in_Buffer (&IN4, in_p[destination]);

/*
   chan_in_word(&msglen,in_p[destination]);
   chan_in_message(msglen,&IN4, in_p[destination]);
*/
   for(j = 0; j < ndime; j++) IN4.resid[j] += IN.r[ndime*i + j];/*add to buffer*/

   if(idno < max-1)  /* for intermediate subdomain send to next one*/
   {
   destination = IN.mark[4*i+prev_ii+1]-1; /* to next */

   e_chan_out_Buffer (&IN4, msglen, out_p[destination]);

/*
   chan_out_word(msglen,out_p[destination]);
   chan_out_message(msglen,&IN4, out_p[destination]);
*/
   }
}

}

void b_ex_2(int i, int msglen, int max, int min, int prev_ii)
{
int j, vali, destination;
double  val;


if(idno == max-1)
{
   destination = IN.mark[4*i+prev_ii]-1;       /* send to prev */
   memcpy(&(IN.r[ndime*i+0]), IN4.resid, sizeof(double)*ndime);

   e_chan_out_Buffer (&IN4, msglen, out_p[destination]);
/*
   chan_out_word(msglen,out_p[destination]);
   chan_out_message(msglen, &IN4, out_p[destination]);
*/
return;
}
if(idno == min-1)
{
   destination = IN.mark[4*i+0]-1; /*receive from 1st entry of mark */
   alt_wait(1, in_p[destination]);

   e_chan_in_Buffer (&IN4, in_p[destination]);
/*
   chan_in_word(&msglen, in_p[destination]);
   chan_in_message(msglen,&IN4, in_p[destination]);
*/
   memcpy(&(IN.r[ndime*i+0]), IN4.resid, sizeof(double)*ndime);
return;
}

/* if its niether the max or min subdomain then it is an intermediate
   subdomain which must receive and send */

   destination = IN.mark[4*i+prev_ii+1]-1;/*from next to prev*/
   alt_wait(1, in_p[destination]);

   e_chan_in_Buffer (&IN4, in_p[destination]);

/*
   chan_in_word(&msglen, in_p[destination]);
   chan_in_message(msglen,&IN4,in_p[destination]);
*/

   memcpy(&(IN.r[ndime*i+0]), IN4.resid, sizeof(double)*ndime);
   destination = IN.mark[4*i+prev_ii]-1;/* to prev */

   e_chan_out_Buffer (&IN4, msglen, out_p[destination]);

/*
   chan_out_word(msglen,out_p[destination]);
   chan_out_message(msglen, &IN4, out_p[destination]);
*/


}



double receive_send_1(double eng_g)
{
register i;
int msglen, vali;
double val;

    msglen = sizeof(IN3); /* constant for IN3*/

   if(no_of_sds < t_sds){
		     /* receive energy from workers below pass or add up*/
    alt_wait(1, in_p[idno+1]);

    e_chan_in_Buffer(&IN3, in_p[idno+1]);

/*
    chan_in_word(&msglen, in_p[idno+1]);
    chan_in_message(msglen, &IN3, in_p[idno+1]);
*/
    if(idno > 0){
    IN3.eng += eng_g;               /* add task's own energy to out buffer */

    e_chan_out_Buffer(&IN3, msglen, out_p[idno-1]);

/*
    chan_out_word(msglen, out_p[idno-1]);
    chan_out_message(msglen, &IN3, out_p[idno-1]);
*/
    return;
    }

    eng = eng_g += IN3.eng; /* energy from another sub-domain is
			       added at root*/
    }
    else               /* means last processor with last sub-domain */
    {
    /* send energy to the 1st task ie on root*/
    val = IN3.eng = eng_g;                 /* load bufer */

     msglen = sizeof(IN3);

     e_chan_out_Buffer (&IN3, msglen, out_p[idno-1]);

/*
     chan_out_word(msglen, out_p[idno-1]);
     chan_out_message(msglen, &IN3, out_p[idno-1]);
*/
    }

return(eng_g);
}


double receive_send_2(double eng_g)
{
register i;
int msglen, vali;
double val;

    msglen = sizeof(IN3);  /* fixed message length for IN3 */

    if(idno == 0)    /* send total energy to all other workers */
    {
    val = IN3.eng = eng_g;                 /* load bufer */

    e_chan_out_Buffer(&IN3, msglen, out_p[idno+1]);

/*
    chan_out_word(msglen, out_p[idno+1]);
    chan_out_message(msglen, &IN3, out_p[idno+1]);
*/
    }
    else{                      /* receive total energy from task 1*/
    alt_wait(1, in_p[idno-1]);

    e_chan_in_Buffer (&IN3, in_p[idno-1]);

/*
    chan_in_word(&msglen, in_p[idno-1]);
    chan_in_message(msglen, &IN3, in_p[idno-1]);
*/
    val = eng = IN3.eng;  /* total energy received */

    if(idno < t_sds-1){

    e_chan_out_Buffer(&IN3, msglen, out_p[idno+1]);

/*
     chan_out_word(msglen, out_p[idno+1]);
     chan_out_message(msglen, &IN3, out_p[idno+1]);
*/
    }

    }

return(eng_g);
}




/*  Form stiffness matrices for in-plane action of elements and add b'c's */
void pform_p(void)
{
		     /* SUBROUTINE PFORM */

    int          kbug,nq,in,l,n1,n2,n3,i,j,mt,k;
    double       e,vv,th,dtl[3],dtt[3][3],sum,pie,anx,bot,dd[3][3];
    double       ax[3],bx[3],cx[3],ang[3],anax[3],rint[3][3],g[3][3];
    double       thic,com,s,area,at;


    for (l=0; l<ne; ++l)                    /* For each element           */
    {
/*        nq  =  IN.mbc[4*l+3] - 1; */
	  e   =  IN.amat[0][0];
	  vv  =  IN.amat[0][1];
	  thic  =  IN.amat[0][2]/1000.00;

	  n1 = IN.nod[6*l+0] - 1;
	  n2 = IN.nod[6*l+1] - 1;
	  n3 = IN.nod[6*l+2] - 1;
	  sidelen_p(n1,n2,n3,dtl,dtt);

      sum = 0;                              /* Calculate internal angles  */
      for (i=0; i<3; i++)
	  sum += dtl[i]*dtl[i];
	  ang[0] = acos((sum - 2.0*dtl[0]*dtl[0]) / (2.0*dtl[1]*dtl[2]));
	  ang[1] = acos((sum - 2.0*dtl[1]*dtl[1]) / (2.0*dtl[0]*dtl[2]));
	  ang[2] = acos((sum - 2.0*dtl[2]*dtl[2]) / (2.0*dtl[1]*dtl[0]));
	  pie = atan(1.0) * 4.0;
	  anax[0] = 0.0;                   /* Transformation angles to give   */
	  anax[1] = pie - ang[2];          /* side rotations to x-y axes.     */
	  anax[2] = pie + ang[1];
	  for (j=0; j<3; ++j)
	  {
		anx = anax[j];
		ax[j] = cos(anx) * cos(anx);
		bx[j] = sin(anx) * sin(anx);
		cx[j] = sin(anx) * cos(anx);
	  }
      /* Evaluate Transformation matrix */
      bot =  ax[0] * (bx[1]*cx[2] - cx[1]*bx[2])
	    -bx[0] * (ax[1]*cx[2] - cx[1]*ax[2])
	    +cx[0] * (ax[1]*bx[2] - bx[1]*ax[2]);
	  g[0][0] = ((bx[1]*cx[2]) - (bx[2]*cx[1])) / (bot*IN.ols[3*l+0]);
	  g[0][1] = ((bx[2]*cx[0]) - (bx[0]*cx[2])) / (bot*IN.ols[3*l+1]);
	  g[0][2] = ((bx[0]*cx[1]) - (bx[1]*cx[0])) / (bot*IN.ols[3*l+2]);
	  g[1][0] = ((ax[2]*cx[1]) - (ax[1]*cx[2])) / (bot*IN.ols[3*l+0]);
	  g[1][1] = ((ax[0]*cx[2]) - (ax[2]*cx[0])) / (bot*IN.ols[3*l+1]);
	  g[1][2] = ((ax[1]*cx[0]) - (ax[0]*cx[1])) / (bot*IN.ols[3*l+2]);
	  g[2][0] = ((ax[1]*bx[2]) - (ax[2]*bx[1])) / (bot*IN.ols[3*l+0]);
	  g[2][1] = ((ax[2]*bx[0]) - (ax[0]*bx[2])) / (bot*IN.ols[3*l+1]);
	  g[2][2] = ((ax[0]*bx[1]) - (ax[1]*bx[0])) / (bot*IN.ols[3*l+2]);

      for (i=0; i<3; ++i)            /* Form the elasticity matrix D */
	  for (j=0; j<3; dd[i][j++] = 0.0);

      com  = e / (1.0 - vv*vv);
      dd[0][0] = dd[1][1] = com;
      dd[0][1] = dd[1][0] = com*vv;
      dd[2][2] = com * (1.0-vv)/2.0;

      for (j=0; j<3; j++)           /* calculate [D] * [G] (= rint)   */
		for (i=0; i<3; i++)
		{
		  rint[j][i] = 0.0;
		  for (k=0; k<3; k++)
			rint[j][i] += dd[j][k] * g[k][i];
		}

      s =  (dtl[0]+dtl[1]+dtl[2])/2.0; /* Area - using S formula - Zeinc. */
      area = sqrt(s * (s-dtl[0]) * (s-dtl[1]) * (s-dtl[2]));
      at = area * thic;
      for (j=0; j<3; j++)
		for (i=0; i<3; i++)
		{
		  ok_p[36*l+6*j+i] = 0.0;
		  for (k=0; k<3; k++)
			ok_p[36*l+6*j+i] += g[k][j] * rint[k][i] * at;
		}
	}
}


void sync(void)
{
int dummy;


    if(idno == 0)
    {
    alt_wait(1, in_p[idno]);               /*wait here for master signal*/
    chan_in_word(&dummy, in_p[idno]);
    chan_in_message(dummy, (char *) &dummy, in_p[idno]);

    chan_out_word(dummy, out_p[idno+1]);
    chan_out_message(dummy, (char *) &dummy, out_p[idno+1]);
    return;
    }

    if(idno > 0)
    {
    alt_wait(1,in_p[idno-1]);
    chan_in_word(&dummy, in_p[idno-1]);
    chan_in_message(dummy, (char *) &dummy, in_p[idno-1]);

      if(idno < t_sds-1)/* if not the last worker then pass on */
      {
       chan_out_word(dummy, out_p[idno+1]);
       chan_out_message(dummy, (char *) &dummy, out_p[idno+1]);
      }

   }

}



void receive_signal(void)
{
int dummy;


    alt_wait(1, in_p[idno]);               /*wait here for master signal*/
    chan_in_word(&dummy, in_p[idno]);
    chan_in_message(dummy, (char *) &dummy, in_p[idno]);

}