#include"plotpp.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#ifdef __TURBOC__
#include<alloc.h>
#else
#include<malloc.h>
#endif


/* Global variables */
extern int triang, cable, autoscale, sepele, string, err, stres, dec,eps;
extern int numyes, nuele,views;
extern char titel[100];
extern char *plotfile;
extern char device[2];
extern int plotline;
extern float sfs;
extern float dt,damp,brightness, red, green, blue;
extern int  nn,ne,nb,nm,nl,ndime,kt,nt,nstr,nbe,kmax,nmax,iln,nq;
int nodq[10][4],mat[10];
int far nod[5000][5];
float tcor[5000][2],amat[10][10];
extern float  aminst, amaxst, amaxer, aminer;
extern int ipv, norm;
extern float b, af;
extern float redfact, scalefac, shiftx, shifty;
extern char til[80];
extern char calcomp[2], laser[2], screen[2];
extern int xxmax,xxmin,yymax,yymin;
extern int nin, nout;
float *errorr;
extern FILE *in,*out,*eorr,*stress,*c100,*decom;
extern int nxx;

/* function to read the input data in */
data()
{
  int l,n1,iq,k,i,ii,n,jj,jj1;
  float fnn,fne,fnb,fnm,fnl,fndime,fnstr,fnbe,fkmax,fnmax,filn,fnq,fn;
  float fnx,nd11,nd22,nd33,nd44,fn1,fm,z;
  char buff[80];

  errorr=(float*)malloc(5000*sizeof(float));
  if(!errorr)
   {
    printf("\nCannot allocate the memory for the error");
    exit();
   }

  fgets(titel,80,in);
  fprintf(out,"\n\n data and results \n  %s", titel);
  if(fscanf(in,"%f%f",&dt,&damp)!=2)  printf("read error 1");
  fprintf(out,"\n timestep  dt=%f     damp=%f", dt,damp);

if(fscanf(in,"%f%f%f%f%f%f%f%f%f%f%f",&fnn,&fne,&fnb,&fnm,&fnl,&fndime,&fnstr,&fnbe,&fkmax,&fnmax,&filn)!=11)
  printf("read errorr 2");
  fscanf(in,"%f",&fnq);

   nn=(int)(fnn);   ne=(int)(fne);
   nb=(int)(fnb);   nm=(int)(fnm);
   nl=(int)(fnl);   ndime=2;
   nstr=(int)(fnstr);   nbe=(int)(fnbe);
   kmax=(int)(fkmax);   nmax=(int)(fnmax);
   iln=(int)(filn);   nq=(int)(fnq);

  fprintf(out,"\n no of nodes=%d\n no of elements=%d",nn,ne);
  fprintf(out,"\n no of restrainted boundary nodes=%d\n no of material types=%d",nb,nm);
  fprintf(out,"\n no of links=%d\n no of dimensions=%d\n no of strs=%d\n no beams=%d",nl,ndime,nstr,nbe);
  fprintf(out,"\n no of itgrps=%d\n no of itbtwp=%d",kmax,nmax);
  fprintf(out,"\n\n no of quadrilaterals=%d",nq);
  fprintf(out," \n0 if no loads=%d",iln);
  printf("%d",iln);
  for (l=1;l<=nn; l++)
    {
      fscanf(in,"%f",&fn);

    n=(int)(fn);

    fscanf(in,"%f%f%f",&tcor[n][0],&tcor[n][1],&z);
    }

  for(n1=1;n1<=nn;n1++)
    {
      fprintf(out,"\n node=%d                cords=",n1);
       for(i=0;i<=(ndime-1);i++)
	  {
	    fprintf(out,"    %f ", tcor[n1][i]);
	  }
     }

  if (ne>0)
    {
		 for(jj=1;jj<=ne;jj++)
		   {
		      fscanf(in,"%f%f%f%f",&fnx,&nd11,&nd22,&nd33);
		      fgets(buff,80,in);
		       nd44=1.0;
		       nxx=(int)(fnx);
		       nod[jj][1]=(int)(nd11);
		       nod[jj][2]=(int)(nd22);
		       nod[jj][3]=(int)(nd33);
		       nod[jj][4]=(int)(nd44);
		    }
		 for(jj1=1;jj1<=ne;jj1++)
		    {
		      fprintf(out,"\n element =%d node1=%d node2=%d node3=%d mat no=%d\n",jj1,nod[jj1][1],nod[jj1][2],nod[jj1][3],nod[jj1][4]);
		     }
      }

  if (nq>0){
		 fprintf(out,"\n Quadrilateral elements\n element           nodal topology           material no");
		 for(iq=1;iq<=nq;iq++)
		    {
		       fscanf(in,"%f%f%f%f%f",&fnq,&fnx,&nd11,&nd22,&nd33);
		       fgets(buff,80,in);
		       nd44=1.0;
		       n=(int)(fnq);
		       nodq[iq][0]=(int)(fnx);
		       nodq[iq][1]=(int)(nd11);
		       nodq[iq][2]=(int)(nd22);
		       nodq[iq][3]=(int)(nd33);
		       fprintf(out,"\n %d     %d %d %d %d      %d", n,nodq[iq][1],nodq[iq][2],nodq[iq][3],nodq[iq][4],nodq[iq][5]);
		     }
	    }

   fprintf(out,"\n material data");

   for(l=1;l<=nm;l++){
		       fscanf(in,"%f %f %f %f %f %f %f",&fn1,&fm,&amat[l][1],&amat[l][2],&amat[l][3],&amat[l][4],&amat[l][5]);
		       n=(int)(fn1);
		       mat[l]=(int)(fm);
		       fprintf(out," \nmaterial number %d   %d        %f   %f   %f   %f   %f",n,mat[n],amat[n][1],amat[n][2],amat[n][3],amat[n][4],amat[n][5]);
		     }


/* open and read decomposited file which control which element belong to
which subdomain */

    if(dec){
	     if((decom=fopen("decom.dat","r"))==NULL){
		printf("Can not open decomposition file\n");
		exit(1);
		}
	      if(ne>0)
	       {
	       for (k=1;k<=ne;k++)
		 {
		   fscanf(decom,"%f",(errorr+k));
		   *(errorr+k)=*(errorr+k)/100;
		  }
	       }
	       if(nq>0)
	       {
		for(k=1;k<=nq;k++)
		 {
		  fscanf(eorr,"%f",(errorr+k));
		  if(norm==1) maxerr();
		  else *(errorr+k)=*(errorr+k)/100;
		 }
	       }
	      }

/* open and read error file which control which element belong to which
subdomain */

    if(err){
	     if((eorr=fopen("error.dat","r"))==NULL){
		printf("Can not open error file\n");
		exit(1);
		}
	      if(ne>0)
	       {
	       for (k=1;k<=ne;k++)
		 {
		   fscanf(eorr,"%f",(errorr+k));
		  }
	       }
	      maxerr();
	    }

/* open and read stress file */

  if(stres){
	     if((stress=fopen("stress.dat","r"))==NULL)
	     {
		printf("Can not open stress file\n");
		exit(1);
	      }
	      printf(" Enter 1 2 3 4 5 for sx sy sxy smax smin\n");
	      scanf("%d",&ipv);

	      switch (ipv)
	       {
		case 1:
		for (k=1;k<=ne;k++)
		 {
		  fscanf(stress,"%f %f %f %f %f",(errorr+k),&fnn,&fne,&fnb,&fnm);
		 }
		break;

		case 2:
		for (k=1;k<=ne;k++)
		 {
		  fscanf(stress,"%f %f %f %f %f",&fnn,(errorr+k),&fne,&fnb,&fnm);
		 }
		break;

		case 3:
		for (k=1;k<=ne;k++)
		 {
		  fscanf(stress,"%f %f %f %f %f",&fnn,&fne,(errorr+k),&fnb,&fnm);
		 }
		break;

		case 4:
		for (k=1;k<=ne;k++)
		 {
		  fscanf(stress,"%f %f %f %f %f",&fnn,&fne,&fnb,(errorr+k),&fnm);
		 }
		break;

		case 5:
		for (k=1;k<=ne;k++)
		 {
		  fscanf(stress,"%f %f %f %f %f",&fnn,&fne,&fnb,&fnm,(errorr+k));
		 }
		break;
	      }
	  maxerr();
	   }
    return 1;
 }

/* function to get the Max and Min values of error */
maxerr()
{
  int i;
  amaxer=errorr[1];

  for(i=1;i<=ne;i++)
      {
	 if(amaxer<fabs(*(errorr+i)))  amaxer=fabs(*(errorr+i));
	 aminer=amaxer;
      }

   for(i=1;i<=ne;i++)
      {
	  if(aminer>fabs(*(errorr+i))) aminer=fabs(*(errorr+i));
      }

    if(amaxer<=0.0)
     {
      printf("\n there might be bugs in input data file");
      printf("\n double check them out...... \nprogram terminated");
      exit(2);
     }
    return 1;
}

/* convert the element's error to number of subdomains which are
defined by different colours */
index()
{
  int i;
  double sc,ai;
  int jj,kk;
  if(err||stres)
  {
  sc=1/0.24;
  fprintf(c100," \n%lf %lf scale\n times-roman findfont 12 scalefont setfont 711 331 translate", sc,sc);
  for(i=0;i<=10;i++)
    {
      ai=1-i/10;
      jj=i*10;
      kk=(i+1)*10;
      if(kk>100) kk=100;
      fprintf(c100,"\n1  setlinewidth  %lf setgray 0 0 m 12 0 1 12 12 1 0 12 1 closepath gsave\n fill grestore 0 setgray stroke 17 0 m ( %d - %d %) show 0 15 translate", ai,jj,kk);
    }
   }

  return 1;
}

/* shade the elements with respect to specified parameter */

shadedom(j)
int j;
{
  int icerr;
  float ic;
  ic=100*(*(errorr+j));
  icerr=(int)ic;
  switch (icerr)
  {
    case 1:
     red=0;
     green=0;
     blue=1;
     break;

     case 2:
     red=0;
     green=1;
     blue=0;
     break;

     case 3:
     red= 0.9;
     green= 0;
     blue= 0.9;
     break;

     case 4:
     red= 0.9;
     green=0.9;
     blue= 0;
     break;

     case 5:
     red=0;
     green=0.9;
     blue=0.9;
     break;

     case 6:
     red= 0.9;
     green= 0.9;
     blue= 0.9;
     break;

     case 7:
     red= 0.9;
     green=0.7;
     blue=0.7;
     break;

     case 8:
     red= 0.9;
     green= 0.6;
     blue= 0.6;
     break;

     case 9:
     red= 0.9;
     green=0.4;
     blue= 0.4;
     break;

     case 10:
     red=0.8;
     green=0.8;
     blue=0.9;
     break;

     case 11:
     red= 0.2;
     green=0.6;
     blue=0.9;
     break;

     case 12:
     red= 0.7;
     green= 0.4;
     blue=0.9;
     break;

     case 13:
     red=0.7;
     green=0.9;
     blue= 0.7;
     break;

     case 14:
     red=0.7;
     green=0.9;
     blue=0.4;
     break;

     case 15:
     red= 0.5;
     green= 0.7;
     blue=0.5;
     break;

     case 16:
     red=0.5;
     green=0.5;
     blue=0.5;
     break;

   }

   fprintf(c100,"\nclosepath gsave %f %f %f   setrgbcolor  fill             \ngrestore stroke", red,green,blue);
   fprintf(c100,"\n0.0  setgray");

   return 1;
}

/* paint the color legend for error and stress */

indexerrstr()
{
  int i,jj;
  double amaxstr,sc,ai;

  if (err || stres)
    {
      sc=1/0.24;
      fprintf(c100,"\n%f %f  scale\n/times-roman findfont 12 scalefont setfont 711 331 translate", sc,sc);
      for (i=0;i<=10;i++)
	{
	  if (stres)
	   {
	     amaxstr=fabs(aminer);
	     if (fabs(amaxer)>fabs(aminer)) amaxstr=fabs(amaxer);
	     if (i<5) ai=(5-i)/5.0*(-amaxstr);
	     else if (i>5) ai=(i-5)/5.0*amaxstr;
	     else ai=0;
	     getrgbstr(ai);
	   }
	   else
	    {
	     ai=i/10.*amaxer;
	     getrgberr(ai);
	    }

/*	 jj=i*10; */

	    if(err)
	     {
	     fprintf(c100,"\n1.0  setlinewidth %f  %f  %f setrgbcolor",red, green, blue);
	     fprintf(c100,"\n0 0 m 12 0 l 12 12 l 0 12 l closepath gsave");
	     fprintf(c100,"\nfill grestore 0 setgray stroke 17 0 m ( %f% ) show 0 15 translate",ai);
	    }
	   else if(stres)
	     {
	     fprintf(c100,"\n1.0  setlinewidth %f  %f  %f setrgbcolor",red, green, blue);
	     fprintf(c100,"\n0 0 m 12 0 l 12 12 l 0 12 l closepath gsave");
	     fprintf(c100,"\nfill grestore 0 setgray stroke 17 0 m ( %f ) show 0 15 translate",ai);
	    }
	   else fprintf(c100,"\n1 setlinewidth %f %f %f setrgbcolor 0 0 m	   12 0 1 12 12 1 0 12 1 closepath gsave fill \ngrestore \n0 setgray stroke 17 0 m ( %lf ) show 0 15 translate", red,green,blue,ai);
	}
      }
     return 1;
 }


/* shade the elements with respect to specified stress */

shadste(i) /*(int i)  */
int i;
{
 double shade;

 if(stres)
   {

/*
if(fabs(fabs(errorr[i])/amaxer)>=1) shade=0.0;
     if(fabs(fabs(errorr[i])/amaxer)<1) shade=0.1;
     if(fabs(fabs(errorr[i])/amaxer)<0.9) shade=0.2;
     if(fabs(fabs(errorr[i])/amaxer)<0.8) shade=0.3;
     if(fabs(fabs(errorr[i])/amaxer)<0.7) shade=0.4;
     if(fabs(fabs(errorr[i])/amaxer)<0.6) shade=0.5;
     if(fabs(fabs(errorr[i])/amaxer)<0.5) shade=0.6;
     if(fabs(fabs(errorr[i])/amaxer)<0.4) shade=0.7;
     if(fabs(fabs(errorr[i])/amaxer)<0.3) shade=0.8;
     if(fabs(fabs(errorr[i])/amaxer)<0.2) shade=0.9;
     if(fabs(fabs(errorr[i])/amaxer)<0.1) shade=1.0;
*/
     getrgbstr(errorr[i]);

     printf("%f %f",red,green);

//     fprintf(c100,"\nclosepath gsave %f setgray fill \ngrestore stroke",shade);
     fprintf(c100,"\nclosepath gsave  %f  %f  %f setrgbcolor fill \ngrestore stroke",red,green,blue);

     fprintf(c100,"\n0.0 setgray ");
   }

  return 1;
}

/* set rgb colours for stresses */
/* function getrgbstr */
getrgbstr(esvalue)
double esvalue;
{
  double btf;
  double amaxstr,colfac1,colfac2,colfac3;
  amaxstr=abs(aminer);
  if(fabs(amaxer)>fabs(aminer)) amaxstr=fabs(amaxer);

  btf=1-brightness;

  if(esvalue<0)
  {
    red=1.0;
    green=0.0;
    blue=0.0;
    colfac1=1.0-red;
    colfac2=1.0-green;
    colfac3=1.0-blue;
    amaxstr=-1.0*amaxstr;
    red=1.0-pow( (esvalue/amaxstr*colfac1), btf);
    green=1.0-pow( (esvalue/amaxstr*colfac2), btf);
    blue=1.0-pow(  (esvalue/amaxstr*colfac3), btf);
   }
   else
    {
      red=0.0;
      green=1.0;
      blue=0.0;
      colfac1=1.0-red;
      colfac2=1.0-green;
      colfac3=1.0-blue;
      red=1.0-pow( (esvalue/amaxstr*colfac1), btf);
      green=1.0-pow( (esvalue/amaxstr*colfac2),btf);
      blue=1.0-pow(  (esvalue/amaxstr*colfac3),btf);
   }
  return 1;
}
