
#include  <stdio.h>
#include  <stdlib.h>
#include  <math.h>
#include  <graphics.h>
#define   XX  extern             /*  set global variables to external */
#include  "plt.h"

struct palettetype Save_pal;

/* Produce the Error or Stress Plots */
avstrsplot(float redfact)
{
    void   strsdat();
    void   plotkey(float);
    void change_palette(void);

    int    ie,is,i,j,node,colour,corner,triangle[6];
    float  avstr,strmax,strfact,strs,xcent,ycent;
    float  elstress,x[3],y[3];


    strsdat();               /* Read stress data from file         */

    switch(idx){
    case 1: j = 0; break;
    case 2: j = 1; break;
    case 3: j = 2; break;
    default: j= 0; break;}

    strmax = 0.0;                  /* Find max absolute stress or error */
    for (ie=0; ie < ne; ++ie)
    {
      strs = fabs(str[3*ie+j]);
      if (strs > fabs(strmax))
      strmax = strs;
    }

    strmax *= 1.01;                /* make sure stresses are within range */
    strfact = strmax/5.5;
    plotkey(strfact);              /* Plot colour key to stress grades    */

    for (ie=0; ie<ne; ++ie)        /* Find centre coordinates of element  */
    {
      xcent = ycent = 0.0;
      for (i=0; i<3; ++i)
      {
	node = nod[4*ie+i] - 1;
	xcent += tcor[2*node+0];
	ycent += tcor[2*node+1];
      }
      xcent /= 3.0;
      ycent /= 3.0;

      elstress = str[3*ie+j];
      colour = (int)(elstress/strfact + 10.5);
      if(idx == 5)  /* for decomposion */
      {
      getpalette(&Save_pal);
      change_palette();
      colour = (int) str[3*ie+0];
      if(abs(colour-3) == 0) colour = 13;
      }
      setcolor(colour);
      setfillstyle(SOLID_FILL,colour);
      for (corner=0; corner<3; ++corner)
      {
      	node = nod[4*ie+corner] - 1;
      	x[corner] = tcor[2*node+0];
      	y[corner] = tcor[2*node+1];
	if (redfact > 0.0)
	{
          x[corner] += (xcent-x[corner])*redfact;
          y[corner] += (ycent-y[corner])*redfact;
	}
      	i = corner*2;
        triangle[i]   = (int)(cmxoff2 + sf*x[corner]);
        triangle[i+1] = (int)(twdowy - cmyoff2 - sf*y[corner]);
      }
      fillpoly(3,triangle);
    }
setallpalette(&Save_pal);
return;
}



void change_palette(void)
{

setpalette(1,EGA_BLUE);
setpalette(2,EGA_GREEN);
setpalette(3,EGA_CYAN);
setpalette(4,EGA_RED);
setpalette(5,EGA_MAGENTA);
setpalette(6,EGA_LIGHTGRAY);
setpalette(7,EGA_BROWN);
setpalette(8,EGA_DARKGRAY);
setpalette(9,EGA_LIGHTBLUE);
setpalette(10,EGA_LIGHTGREEN);
setpalette(11,EGA_LIGHTCYAN);
setpalette(12,EGA_LIGHTRED);
setpalette(13,EGA_LIGHTMAGENTA);
setpalette(14,EGA_YELLOW);
setpalette(15,EGA_WHITE);
}