#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#define   XX   extern
#include  "plt.h"


/*  establish plotter options   */
void options()
{

    void  freadopts  (bool *);
    void  fwriteopts (void);

    bool  change,save,file;

    freadopts  (&file);
    if (file == FALSE)
	change = TRUE;
    else {
	printopts ();
	getchoice (&change,"\n\n Do you wish to change any of the plot options? (T/F)");
    }
    if (change == TRUE) {
	while (change == TRUE) {
	    getdev (&device,"\n Output device?  (Calcomp, Laser, Screen; C/L/S)");
	    getchoice (&triang,"\n Plot membrane elements? (T/F)");
	    getchoice (&cable,"\n Plot cable elements? (T/F)");
	    getchoice (&string,"\n Plot Geodesic-strings? (T/F)");
	    getchoice (&numyes,"\n Number nodes? (T/F)");
	    getchoice (&nuele,"\n Number elements? (T/F)");
	    getfloat  (&redfact,"\n Element reduction factor? (0.0-1.0) ");
	    getchoice (&autoscale,"\n Use automatic scaling? (T/F)");
	    if (autoscale != TRUE)
		getfloat (&sfs,"\n Scale factor? ");

	    printopts  ();
	    getchoice (&change,"\n\n Do you wish to change any of the plot options? (T/F)");
	}
	getchoice (&save,"\n\n Do you wish to save the new plot options? (T/F)");
	if (save == TRUE)
	    fwriteopts ();
    }
}

/* Print plot options to screen */
void printopts ()
{
    extern float redfact, sfs;

    clearscreen ();

    printdev ("\n\nOutput device?  (Calcomp, Laser, Screen; C/L/S) \t",device);
    printchoice ("Plot membrane elements? (T/F) \t",triang);
    printchoice ("Plot cable elements? (T/F) \t",cable);
    printchoice ("Plot Geodesic-strings? (T/F) \t",string);
    printchoice ("Plot membrane elements? (T/F) \t",triang);
    printchoice ("Number nodes? (T/F) \t",numyes);
    printchoice ("Number elements? (T/F) \t",nuele);
    printfloat ("Element reduction factor? (0.0-1.0) \t",redfact);
    printchoice ("Use automatic scaling? (T/F) \t",autoscale);
    if (autoscale != TRUE)
     printfloat("Scale factor?                       \t",sfs);
}

void clearscreen ()
{
     clrscr();

/*     int i;

    for (i=0; i<50; ++i)
	printf ("\n");  */
}

/*  output option to screen  */
void printdev (char *text, char value)
{
    printf ("%-50s",text);

    switch (value) {
	case 'c':
	    printf (" Calcomp \n");
	    break;
	case 'l':
	    printf (" Laser \n");
	    break;
	case 's':
	    printf (" Screen \n");
	    break;
	default:
	    printf (" Output device %s not valid \n",value);
	    break;
    }
}


/*  output option to screen  */
void printchoice (char *text, int value)
{
    printf ("%-50s",text);
    if (value == TRUE)
	printf ("\t True\n");
    else
	printf ("\t False\n");
}


/*  output option to screen  */
void printfloat (char *text, float value)
{
    printf ("%-50s%10.4f\n",text,value);
}

/*  get device type from screen */
void getdev (char *character, char *text)
{
    int ch;

    printf ("%s",text);
    if ((*character == 'c') || (*character == 'l') || (*character == 's'))
	printf ("  [ %c ]:",toupper(*character));
    ch = getch();
    if (ch != '\r') {
	ch = ch & 0x7F;
	*character = ch;
    }
    printf (" %c\n",toupper(*character));
}


/*  get plot option from screen */
void getchoice (int *option, char *text)
{
    int i;

    printf("%s",text);

    if (*option == TRUE)
	printf ("  [ T ]:");
    else
	printf ("  [ F ]:");

    i = getch();

    if (i != '\r') {
	i = i & 0x7F;
	if (i == 't')
	    *option = TRUE;
	else
	    *option = FALSE;
    }
    if (*option == TRUE)
	printf ("  T\n");
    else
	printf ("  F\n");


}

/*  get float variable from screen */
void getfloat (float *value, char *text)
{
    char  c[80];
    int   i;

    printf ("%s  [ %f ]:",text,*value);
    gets (c);
    if (c[0] != '\0')
	*value = atof(c);
    printf ("  %f\n",*value);
}




/* Read plot options from file */
void freadopts (bool *newfile)
{
    extern float redfact,sfs;

    FILE *fp;

    if ((fp = fopen ("opts.dat","r")) == NULL)
	*newfile = FALSE;
    else {
	*newfile = TRUE;
	device    = fgetc (fp);
	triang    = fgetc (fp);
	cable     = fgetc (fp);
	string    = fgetc (fp);
	numyes    = fgetc (fp);
	nuele     = fgetc (fp);
	fscanf(fp,"%f\n",&redfact);
	autoscale = fgetc (fp);
	fscanf(fp,"%f\n",&sfs);
    }
    fclose (fp);
}


/* Write plot options to file */
void fwriteopts ()
{
    extern float redfact, sfs;

    FILE *fp;

    fp = fopen ("opts.dat","w");

    fputc   (device,fp);
    fputc   (triang,fp);
    fputc   (cable,fp);
    fputc   (string,fp);
    fputc   (numyes,fp);
    fputc   (nuele,fp);
    fprintf (fp,"\n %10.4f \n",redfact);
    fputc   (autoscale,fp);
    fprintf (fp,"\n %10.4f\n",sfs);

    fclose (fp);
}


