/*                          PLT.H                               */

/*               Header file for PLOT.C                         */

#define    FALSE      0
#define    TRUE  !FALSE

#define    MN    550
#define    ME    900
#define    MB    50
#define    ML     20
#define    MM      3
#define    MDIME   3
#define    MSTR    5
#define    MBE    20
#define    MLN    30
#define    MGS     5

typedef   int   bool;       /* define bool as int datatype */

XX FILE     *fpout;
XX char     titel[50], file[20], outfile[20], infile[20], device;
XX bool     triang, cable, numyes, autoscale, nuele, string;
XX int      nn, ne, nb, nm, nl, ndime, nstr, nbe, kmax, nmax, iln;
XX int      *nod, nodl[ML][3], mat[MM], nco[MB][MDIME+1], nc[MLN];
XX float    dt, damp, ff, redfact, sfs,sf,cmxoff2,cmyoff2,twdowx,twdowy;
XX float    *cord, /* *ols,  */ amat[MM][5], aload[MLN][MDIME];
XX float    *tcor;
XX float    *str;


XX int idx, next;

XX char file_name[30];

/*   Definitions for use in our Finite Element Packages   */


void options     (void);           /* establish plot options */
void clearscreen (void);
void printopts   (void);            /* print plot options */
void printchoice (char *,int);      /* print True or False */
void printdev    (char *,char);     /* print device type */
void printfloat  (char *,float);    /* print floating point option */
void data        (void);            /* read data from file */
void plot        (void);            /* perform graphics operations */
void view        (void);            /* establish which view(s) to be plotted*/
void getchoice   (int *,char *);    /* assign boolean to int */
void getfloat    (float *,char *);  /* assign float variable to float */
void getdev      (char *,char *);   /* assign device type to char */
int  getview     (char *, int *, int *, char *);
				    /* assign required view type */
