
#include  <stdio.h>
#include <stdlib.h>
#include  <math.h>
#include  <graphics.h>
#define   XX  extern             /*  set global variables to external */
#include  "plt.h"

/* Produce Stress Plots */
strsplot(float redfact)
{
    void   strsdat();
    void   plotkey(float);

    int    ie,node,is,i,n1,n2,colour,corner,triangle[6];
    float  *str,strmax,strfact,elstress,xcent,ycent,x[2],y[2];

    strsdat();               /* Read stress data from file  */

    strmax = 0.0;                  /* Find max absolute stress           */
    for (ie=0; ie<ne; ++ie)  {
      for (is=0; is<3; ++is)
	if (fabs(str[3*ie+is]) > fabs(strmax))
	  strmax = fabs(str[3*ie+is]);
    }
    strmax *= 1.01;                /* make sure stresses are within range */
    strfact = strmax/5.5;
    plotkey(strfact);              /* Plot colour key to stress grades    */

    for (ie=0; ie<ne; ++ie) {      /* Find centre coordinates of element  */
      xcent = ycent = 0.0;
      for (i=0; i<3; ++i) {
	node = nod[4*ie+i] - 1;
	xcent += tcor[2*node+0];
	ycent += tcor[2*node+1];
      }
      xcent /= 3.0;
      ycent /= 3.0;
      for (is=0; is<3; ++is) {
	elstress = str[3*ie+is];
	colour = (int)(elstress/strfact + 10.5);
    setcolor(colour);
	setfillstyle(SOLID_FILL,colour);
	is<=1 ? (n1 = nod[4*ie+is+1]-1) : (n1 = nod[4*ie+is-2]-1);
	is<=0 ? (n2 = nod[4*ie+is+2]-1) : (n2 = nod[4*ie+is-1]-1);
	x[0] = tcor[2*n1+0];
	y[0] = tcor[2*n1+1];
	x[1] = tcor[2*n2+0];
	y[1] = tcor[2*n2+1];
	if (redfact > 0.0) {
	  for (corner=0; corner<2; ++corner) {
	    x[corner] += (xcent-x[corner])*redfact;
	    y[corner] += (ycent-y[corner])*redfact;
	  }
	}
	triangle[0] = (int)(cmxoff2 + sf*x[0]);
	triangle[1] = (int)(twdowy - cmyoff2 - sf*y[0]);
	triangle[2] = (int)(cmxoff2 + sf*x[1]);
	triangle[3] = (int)(twdowy - cmyoff2 - sf*y[1]);
	triangle[4] = (int)(cmxoff2 + sf*xcent);
	triangle[5] = (int)(twdowy - cmyoff2 - sf*ycent);

	fillpoly(3,triangle);
      }
    }
return;
}



/*  read stress data from file  */
void strsdat()
{
		     /*  STRESS INPUT ROUTINE   */

    FILE    *fpstin;
    int     i,n;
    float dum;
    char    line[180];
    fpstin = fopen(file_name,"r");

  /* ---------- Read Error or Stresses --------- */
    if (ne > 0) {

      for (i = 0; i < ne; i++) {
	fgets  (line, 180, fpstin);
	if(idx== 0 || idx==5)sscanf(line,"%f",&str[3*i+0]); /* error read */
	else
	sscanf (line,"%f %f %f %f %f",
	&str[3*i+0], &str[3*i+1], &str[3*i+2], &dum, &dum); /* stress read */
      }
    }
    close(fpstin);

}

/* Plot colour key to stress grades */
void  plotkey(float strfact)
{
    int   i,colour,grade,xpos,xinc,ypos,yinc;
    int   square[8];
    char  text[100],dummy[20];

    setcolor(1);  /* white */
    yinc = xinc = 10;
    xpos = 10 + xinc;
    for (grade=0; grade<11; ++grade)  {
      colour  =  grade + 5;
      setfillstyle(SOLID_FILL,colour);
      ypos = 25 + grade*yinc;
      square[0] = xpos;
      square[1] = ypos;
      square[2] = xpos+xinc;
      square[3] = ypos;
      square[4] = xpos+xinc;
      square[5] = ypos+yinc;
      square[6] = xpos;
      square[7] = ypos+yinc;
      fillpoly(4,square);

/*      strcpy(text,itoa((grade-5)*(int)(strfact),dummy,10)); */
/*      strcat(text,"  to  ");                                */
/*      strcat(text,itoa((grade-4)*(int)(strfact),dummy,10)); */
/*      strcat(text," kN/m2");                                */
/*      outtextxy(xpos+xinc+15,ypos,text);                    */

      if(idx == 1 || idx == 2 || idx == 3){
      if (grade<6)      /* Print Stress Values */
	strcpy(text,gcvt((grade-5.5)*strfact,4,dummy));
      else
      {
	strcpy(text," ");
	strcat(text,gcvt((grade-5.5)*strfact,4,dummy));
      }
      text[8] = '\0';
      strcat(text," ");
      if (grade>=5)
	strcat(text," ");
      strcat(text,gcvt((grade-4.5)*strfact,4,dummy));
      text[22] = '\0';
      strcat(text," KN/m2");
      outtextxy(xpos+xinc+15,ypos,text);}

    }
}
