/* USES GENETIC CODE FOR SUB-DOMAIN GENERATION */ 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define INT    0
#define NEsub  250
#define NNsub  150
#define NSGT   150
#define SecOrder 0
#define LIL 2
#define MM  15
#define NC  20
#define LASTNODE 1600
#define XX
#define UnBalance 20;   /*used in form_decomp_dec */
/****************** common to objfunc() ***********/
XX int nn, ne, *nod, choice;
XX int ne1, *mark1, ne2, *mark2, *mark2_c;
XX double *cord;
XX double *hi, *hhi, *cg, *area, *err;
XX double maxx,minx, maxy,miny,left_val,right_val,total_val;
XX int    div_hv;
XX double xseg1, yseg1, xseg2, yseg2;
XX int bsgt;
XX int *seg;
/**************************************************/
int t_sds, *ne_g;          /*to trace global elnos*/
int *elems_sd, *elem_sdno;
/**************************************************/
int nb,nm,nl,ndime,nstr,nbe,kmax,nmax,iln,nq;

int nodl[LIL][3],nodq[LIL][5],
nco[MM][4],nsnod[LIL][5],
mat[5],nc[NC],ngs[LIL];

char titel[50];

double dt,damp;

double amat[50],aload[NC*3];


typedef struct{

int nn,ne,nb,nm,nl,ndime,nstr,nbe,kmax,nmax,iln,nq;

int nod[4*NEsub],nodl[LIL][3],nodq[LIL][5],
nco[MM][4],nsnod[LIL][5],
mat[5],nc[5],ngs[LIL];

int ne_g[NEsub]; /*global elnos for the subdoamin*/

double hhi[NNsub], err[NEsub], hi[NEsub];

char titel[50];

double dt,damp;

double cord[3*NNsub];

double amat[50],aload[NC/2*3];
} sub_t;

sub_t SUB;

int *sort;

void print_mark(int it, int rc, FILE *fp1);

void rinput(FILE *);

void rindec(int it, FILE *fp3);

void rinmen(FILE *fp5);

void routput(FILE *);

void routdec(int nex, FILE *fp4);

void routmen(int nnx, int nex, FILE *fp6);

void form_boun(void);

void compare_and_stack(int i);

void stack_seg(int nd1, int nd2);

stack(int elem_g);

int comp_st(double x, double y, double z);

void revise_nod(int trace[], int *pjj, int mat_no);

void nb_iln(void);

void partition(FILE *, FILE *, FILE *);

int sga5(FILE *finf, int it);

void copy(char *arg1, char *arg2);

void init_idec(int *ne_orig);

void node_para_err(char *file_sav);

double neuron(double x[], double y[], double del[] );

void search_node(void);

void form_decomp_dec(int ne_orig);

void load_elem_sdno(register i, int ne_sd);

void rinput_init(char *file);

void filer(int flag, int choice, FILE **fp, FILE **fp2, FILE **fp3, FILE **fp4,
	   FILE **fp5, FILE **fp6);

main()
{
FILE *fp, *fp1,*fp2,*fp3,*fp4, *fp5, *fp6, *finf;
char c, filename[30], filename_sav[30];
register i,j, it, rc;
int flag;
int nrec,nsd;
int ne_orig;
time_t tim1, tim2;



printf("Enter the data file name (without extension)\n");
gets(filename);
strcpy(filename_sav,filename);
strcat(filename,".dat");
copy(filename,"i.dat");

strcpy(filename, filename_sav); strcat(filename,".in"); /*open info file */
if((finf=fopen(filename,"w")) == (FILE *) NULL)
{printf("cannot open %s\n",filename); exit(1);}


printf("Enter [1] if Error-based Decompostion Required Else [0]\n");
gets(filename); sscanf(filename,"%d",&choice);

printf("\n*The number of subdomains to be formed N = 2^(no_of_recursions)*\n");
printf("\nEnter the no_of_recursions\n"); 
scanf("%d",&nrec); 

time(&tim1);

t_sds = (int) pow(2.,nrec); /* total no. of subdomains at any instance */

if((fp1 = fopen("debug.dat","w")) == (FILE *) NULL)
{printf("cannot open w.dat\n"); exit(1);} 

init_idec(&ne_orig);         /* create the i.dec file of global elmos*/

rinput_init(filename_sav);

if(choice)
node_para_err(filename_sav);

if((seg = calloc(NSGT*2,sizeof(int))) == NULL)
{printf("out of memory for seg[]\n"); exit(1);}


for(it = 0; it < nrec; it++)
{
if(fmod(it,2) == 0) flag = 0; else flag = 1;
nsd = pow(2, it);     /* no of subdomains to be generated in this recursion*/

filer(flag,choice,&fp,&fp2,&fp3,&fp4,&fp5,&fp6);

   for(rc = 0; rc < nsd; rc++)
   {
   rinput(fp);  /*read in the input.dat file for the current iter */
   rindec(it,fp3); /*read in the global elem no. info file for this iter */
   if(choice)
   {
   rinmen(fp5);   /* read file.men */
   }
#if INT
   form_boun();
#endif
   sga5(finf, it);         /* divide into two equal parts using genetic algorithm */

   print_mark(it,rc,fp1); /*write the partitioned elems to debug.dat */

   partition(fp2,fp4,fp6); /*compile data structure for each partition and write*/
   }
printf("Recursion no.%3d completed\n", it+1);
fclose(fp);
fclose(fp2);
fclose(fp3);
fclose(fp4);
fclose(fp5);
fclose(fp6);
}

printf("\nThe GAs results from last iter are in *** debug.dat ***\n");
fclose(fp1);

free(mark1);
free(mark2);

#if SecOrder
free(mark2_c);
#endif

if(choice)
{
free(hhi);
free(cg);
free(err);
free(hi);
free(seg);
}

if(fmod(nrec,2) == 0){
copy("i.dat","o.dat");
copy("i.dec","o.dec");
if(choice)
copy("i.men","o.men");
}

form_decomp_dec(ne_orig);

free(cord);
free(nod);


printf("\nThe Decomposed File Generated as *** o.dat ***\n");
if(choice)
printf("The Associated Mesh File is *** o.men ***\n");

strcpy(filename, filename_sav);
strcat(filename,".dec");
copy("decomp.dec",filename);
printf("\nThe Associated Plot File is *** %s ***\n",filename);


remove("i.dat");
remove("i.dec");
remove("o.dec");
remove("decomp.dec");
time(&tim2);
printf("total Time = %f (min)\n",((float)tim2 - (float) tim1)/60.);
fprintf(finf,"total Time = %f (min)\n",((float)tim2 - (float) tim1)/60.);
fclose(finf);
printf("***information file %s.in generated***\n",filename_sav);
return;
}


void print_mark(int it, int rc, FILE *fp1)
{
register i;
   fprintf(fp1,"Recursion No.%3d iter no.%3d \n",
   it+1,rc+1);
   fprintf(fp1,"mark1[0.....%d-1]\n",ne1);
   for(i = 0; i < ne1; i++)
   fprintf(fp1,"%5d  %5d\n",i + 1, mark1[i]);
   fprintf(fp1,"mark2[0.....%d-1]\n",ne2);
   for(i = 0; i < ne2; i++)
   fprintf(fp1,"%5d  %5d\n",i + 1, mark2[i]);
}


/* function to read in the data from the primary data file */

void rinput(FILE *fp11)
{
char bf[256];
int i,j,k,n;
double x1,y1,z1;

   fgets(titel,50,fp11);
   fputs(titel,stdout);
   fgets(bf,256,fp11);
   sscanf(bf,"%lf%lf",&dt,&damp);
   printf("%f %f \n",dt,damp);
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d %d %d %d %d %d %d %d",&nn,&ne,&nb,&nm,&nl,
   &ndime, &nstr, &nbe, &kmax,&nmax, &iln);

   fgets(bf,256,fp11);
   sscanf(bf,"%d",&nq);


   for(i = 0; i < nn; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %lf %lf %lf",&n, &x1, &y1,&z1);
   cord[3*i] = x1;
   cord[3*i + 1] = y1;
   cord[3*i + 2] = z1;
   }



   if(ne > 0)
   {
      for(i = 0; i < ne; i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d %d",&n,&nod[4*i + 0],&nod[4*i + 1],
      &nod[4*i + 2],&nod[4*i + 3]);
      }
   }



   if(nl > 0)
   {
      for(i = 0; i < nl;i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d",&n,&nodl[i][0],&nodl[i][1],
      &nodl[i][2]);
      }
   }



   if(nq > 0)
   {
      for(i = 0; i < nq; i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d %d %d",&n,&nodq[i][0],&nodq[i][1],
      &nodq[i][2],&nodq[i][3],&nodq[i][4]);
      }
   }



   for(i = 0; i < nm; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %lf %lf %lf %lf %lf",&n,&mat[i],&amat[5*i+0],
   &amat[5*i+1],&amat[5*i+2],&amat[5*i+3],&amat[5*i+4]);
   }



   for(i = 0; i < nb; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d",&nco[i][0],&nco[i][1],&nco[i][2],&nco[i][3]);
   }



   if(iln > 0)
   {
   for(i = 0; i < NC; nc[i++] = 0);/*zero for use in nb_iln */
   iln = 0;
more:
   iln++;
   i = iln - 1;

   fgets(bf,256,fp11);
   sscanf(bf,"%d %lf %lf %lf",&nc[i],&aload[3*i+0],
   &aload[3*i+1],&aload[3*i+2]);

   if(nc[i] < nn)
   goto more;
   }

   if(nstr > 0)
   {
   for(i = 0; i < nstr; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d",&ngs[i]);
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d %d %d %d %d",&nsnod[i][0],&nsnod[i][1],
   &nsnod[i][2],&nsnod[i][3],&nsnod[i][4],&nsnod[i][5],&nsnod[i][6],
   &nsnod[i][7]);
   }
   }
}


void rindec(int it, FILE *fp3)
{
register i;
int dum;
char buf[100];

switch(it){
case 0:
if((ne_g = calloc(ne, sizeof(int))) == NULL)
{printf("out of core for ne_g\n"); exit(1);}
break;

default:
break;
}

fgets(buf,100,fp3);

for(i = 0; i < ne; i++)
{fgets(buf,100,fp3);sscanf(buf,"%d %d",&dum, &ne_g[i]);}

}

void rinmen(FILE *fp5)
{
register i;
int dum;
char buf[100];

fgets(buf,100,fp5);       /* read header line */
for(i = 0; i < nn; i++)
{
fgets(buf,100,fp5);
sscanf(buf,"%d %lf",&dum, &hhi[i]);
}

fgets(buf,100,fp5);       /* read header line */
for(i = 0; i < ne; i++)
{
fgets(buf,100,fp5);
sscanf(buf,"%d %lf",&dum, &err[i]);
}

fgets(buf,100,fp5);       /* read header line */

for(i = 0; i < ne; i++)
{
fgets(buf,100,fp5);
sscanf(buf,"%d %lf",&dum, &hi[i]);
}


}


/* function to write in the data to one of the two subdomain files*/

void routput(FILE *fp00)
{
int i,j,k,n, n1,n2,n3,n4;

   fputs((SUB.titel),fp00);
   fprintf(fp00,"%f %f\n",SUB.dt,SUB.damp);
   fprintf(fp00,"%5d%5d%5d%5d%5d%5d%5d%5d%5d%5d%5d\n",
   SUB.nn,SUB.ne,SUB.nb,SUB.nm,SUB.nl,
   SUB.ndime, SUB.nstr, SUB.nbe, SUB.kmax,SUB.nmax, SUB.iln);


   fprintf(fp00,"%5d\n",SUB.nq);

   for(i = 0; i < SUB.nn; i++)
   {
   fprintf(fp00,"%5d%15.5f%15.5f%15.5f\n",i+1, 
   (SUB.cord)[3*i + 0], (SUB.cord)[3*i + 1], (SUB.cord)[3*i + 2]);
   }



   if(SUB.ne > 0)
   {  
      for(i = 0; i < SUB.ne; i++)
      {
      n1 = SUB.nod[4*i + 0];
      n2 = SUB.nod[4*i + 1];
      n3 = SUB.nod[4*i + 2];
      n4 = SUB.nod[4*i + 3];

	  fprintf(fp00,"%5d%5d%5d%5d%5d\n",i+1,n1,n2,n3,n4);
      }
   }



   if(SUB.nl > 0)
   {
	  for(i = 0; i < SUB.nl;i++)
      {
      fprintf(fp00,"%5d%5d%5d%5d\n",i+1,
	  SUB.nodl[i][0],SUB.nodl[i][1],SUB.nodl[i][2]);
      }
   }


   for(i = 0; i < SUB.nm; i++)
   {
   fprintf(fp00,"%5d%5d%12.5e%12.5e%12.5e%12.5e%12.5e\n",i+1,
   (SUB.mat)[i],(SUB.amat)[5*i+0],
   (SUB.amat)[5*i+1],(SUB.amat)[5*i+2],(SUB.amat)[5*i+3],(SUB.amat)[5*i+4]);
   }



   for(i = 0; i < SUB.nb; i++)
   {
   fprintf(fp00,"%5d%5d%5d%5d\n",(SUB.nco)[i][0],
   (SUB.nco)[i][1],(SUB.nco)[i][2],(SUB.nco)[i][3]);
   }



   if(SUB.iln > 0)
   {
   SUB.iln = 0;
more:
   SUB.iln++;
   i = SUB.iln - 1;

   fprintf(fp00,"%5d%15.5f%15.5f%15.5f\n",
   (SUB.nc)[i],(SUB.aload)[3*i+0],(SUB.aload)[3*i+1],
   (SUB.aload)[3*i+2]);

   if(SUB.nc[i] < SUB.nn)
   goto more;
   }

   if(SUB.nstr > 0)
   {
   for(i = 0; i < SUB.nstr; i++)
   {
   fprintf(fp00,"%5d\n",SUB.ngs[i]);
   fprintf(fp00,"%5d%5d%5d%5d%5d%5d%5d%5d\n",
   SUB.nsnod[i][0],SUB.nsnod[i][1],
   SUB.nsnod[i][2],SUB.nsnod[i][3],
   SUB.nsnod[i][4],SUB.nsnod[i][5],
   SUB.nsnod[i][6],SUB.nsnod[i][7]);
   }
   }
}

void routdec(int nex, FILE *fp4)
{
register i;

fprintf(fp4,"%5d          %5d\n",t_sds,nex);

for(i = 0; i < nex; i++)
fprintf(fp4,"%5d %5d\n",i+1, SUB.ne_g[i]);
}

void routmen(int nnx, int nex, FILE *fp6)
{
register i;

fprintf(fp6,"node paras hhi[]\n");
for(i = 0; i < nnx; i++)
fprintf(fp6,"%5d   %lf\n",i+1, SUB.hhi[i]);
fprintf(fp6,"eta_i err[]\n");
for(i = 0; i < nex; i++)
fprintf(fp6,"%5d   %lf\n",i+1, SUB.err[i]);
fprintf(fp6,"elem sizes hi[]\n");
for(i = 0; i < nex; i++)
fprintf(fp6,"%5d   %lf\n",i+1, SUB.hi[i]);
}


/* The function loads in the data structure for a subdomain in SUB 
each element identified by mark1[] & mark2[] has its global element
number passed on to this function                                */

stack(int elem_g)
{
int i,ii,jj,test1;
int trace[3],node, mat_no;
double x[3], y[3], z[3], hhf[3];

   ii = SUB.nn ;
   jj = SUB.ne ;

   for(i = 0; i < 3; i++)
   {
   node = nod[4*(elem_g - 1) + i] - 1;/*load the coordinates of the element*/
   x[i] = cord[3*node + 0];
   y[i] = cord[3*node + 1];
   z[i] = cord[3*node + 2];
   hhf[i] = hhi[node];
   }

   mat_no = nod[4*(elem_g - 1) + 3];/* load the mat number */
   
   

   for(i = 0; i < 3; i++)
   {

     test1 = 0;
     test1 = comp_st(x[i],y[i],z[i]); /*test1 returns the compared node_st*/

     if(test1 == -1)
     {
	 SUB.cord[3*ii + 0] = x[i];
	 SUB.cord[3*ii + 1] = y[i];
     SUB.cord[3*ii + 2] = z[i];
     SUB.hhi[ii]        = hhf[i];
     trace[i] = ii + 1;
     ii++;
     continue;
     }
     trace[i] = test1;
   }

   /* load in the new topology */

   revise_nod(trace, &jj, mat_no);
     

  SUB.nn = ii;
  SUB.ne = jj;

return;
}

/* function to compare the packet nodes with the stack nodes */
int comp_st(double x, double y, double z)
{
int i;
double x_st, y_st, z_st;
double tol = 1.e-4;

   for(i = 0; i < SUB.nn; i++)
   {
   x_st = SUB.cord[3*i + 0];
   y_st = SUB.cord[3*i + 1];
   z_st = SUB.cord[3*i + 2];
      if((fabs(x - x_st) <= tol) && (fabs(y - y_st) <= tol)
	  && (fabs(z - z_st) <= tol))
      return(i + 1);
   }
return(-1);
}

/* function to revise the node topology */

void revise_nod(int trace[], int *pjj, int mat_no)
{
int jj = *pjj;
   SUB.nod[4*jj + 0] = trace[0];
   SUB.nod[4*jj + 1] = trace[1];
   SUB.nod[4*jj + 2] = trace[2];
   SUB.nod[4*jj + 3] = mat_no;
   jj++;

*pjj = jj;

}

/* function to identify the restrained and loaded nodes from the
   compiled mesh */

void nb_iln(void)
{
int i,j,k,l,m,o, node;
double tol = pow(10.,-6);
double cx_b,cy_b,cz_b,cx_l,cy_l,cz_l;
   k = 0;
   m = 0;
   SUB.nb = 0;
   for(i = 0; i < SUB.nn; i++)
   {

      for(j = 0; j  < nb; j++)
      {
       node = nco[j][0] - 1;
	   cx_b = fabs(SUB.cord[3*i + 0] - cord[3*node + 0]);
	   cy_b = fabs(SUB.cord[3*i + 1] - cord[3*node + 1]);
       cz_b = fabs(SUB.cord[3*i + 2] - cord[3*node + 2]);
       if(cx_b <= tol && cy_b<= tol && cz_b <= tol)
       {
		SUB.nco[k][0] = i + 1;
	SUB.nco[k][1] = nco[j][1];
	    SUB.nco[k][2] = nco[j][2];
	    SUB.nco[k][3] = nco[j][3];
	    k++;
	break;
       }
      }

       for(l = 0; nc[l] <= nn && nc[l] != LASTNODE; l++)
       {
	node = nc[l] - 1;
	cx_l = fabs(SUB.cord[3*i + 0] - cord[3*node + 0]);
	cy_l = fabs(SUB.cord[3*i + 1] - cord[3*node + 1]);
	cz_l = fabs(SUB.cord[3*i + 2] - cord[3*node + 2]);
	if(cx_l <= tol &&  cy_l <= tol && cz_l <= tol)
	{
		 SUB.nc[m] = i + 1;
		 for(o = 0; o < 3; o++)
		 SUB.aload[3*m+o] = aload[3*l+o];
	 m++;
	 break;
	}
       }           
   }
   SUB.nb = k;

   if(m == 0){
   SUB.nc[m] = LASTNODE;
   SUB.aload[3*m+0] = SUB.aload[3*m+1] = SUB.aload[3*m+2] = 0.;
   m++;
   SUB.iln = m;
   }
   else{
   SUB.nc[m] = LASTNODE;
   SUB.aload[3*m+0] = SUB.aload[3*m+1] = SUB.aload[3*m+2] = 0.;
   m++;
   SUB.iln = m;
   }
}
 



void partition(FILE *fp2, FILE *fp4, FILE *fp6)
{
register i,l;
int elem_g;

memmove((SUB.titel),titel, sizeof(titel));
memmove((SUB.mat), mat, sizeof(mat));
memmove((SUB.amat),amat,sizeof(amat));
SUB.nn = 0;
SUB.ne = 0;
SUB.nq = 0;
SUB.dt = dt;
SUB.damp = damp;
SUB.ndime = ndime;
SUB.nm =  nm;
SUB.nl = nl;
SUB.nstr = nstr;
SUB.nbe = nbe;
SUB.kmax = kmax;
SUB.nmax = nmax;


for(i = 0; i < ne1; i++)
{
elem_g = mark1[i];
stack(elem_g);
SUB.ne_g[i] = ne_g[elem_g-1];
if(choice)
{
SUB.err[i]  =  err[elem_g-1];
SUB.hi[i]   =   hi[elem_g-1];
}
}
nb_iln();
routput(fp2);
routdec(ne1,fp4);
if(choice)
routmen(SUB.nn,ne1,fp6);

SUB.nn = 0;
SUB.ne = 0;
for(i = 0; i < ne2; i++)
{
elem_g = mark2[i];
stack(elem_g);
SUB.ne_g[i] = ne_g[elem_g-1];
if(choice)
{
SUB.err[i]  =  err[elem_g-1];
SUB.hi[i]   =   hi[elem_g-1];
}
}
nb_iln();
routput(fp2);
routdec(ne2,fp4);
if(choice)
routmen(SUB.nn,ne2,fp6);
}


void copy(char *arg1, char *arg2)
{
FILE *fp1,*fp2;
char *buf;
long f_size;

if((fp1=fopen(arg1,"rb")) == (FILE *) NULL)
{printf("cannot open %s\n",arg1); exit(1);}

if((fp2=fopen(arg2,"wb")) == (FILE *) NULL)
{printf("cannot open %s\n",arg2); exit(1);}

fseek(fp1,0,SEEK_END);
f_size = ftell(fp1);
rewind(fp1);
if((buf=malloc(f_size)) == NULL)
{printf("out of memory\n");exit(1);}
fread(buf,f_size,1,fp1);
fwrite(buf,f_size,1,fp2);
free(buf);
fclose(fp1);
fclose(fp2);
}

void init_idec(int *ne_orig)
{
register i;
FILE *fl1, *fl2;
char buf[256];

/* creates the first i.dec file containing the global element numbers
for the initial domain and  allocates men[] if choice == [1]*/

if((fl1 = fopen("i.dat","r")) == (FILE *) NULL)
{printf("cannot open i.dat in init_dec()\n"); exit(1);}
fgets(buf,256,fl1);
fgets(buf,256,fl1);
fgets(buf,256,fl1);
sscanf(buf,"%d %d %d %d %d %d %d %d %d %d %d",&nn,&ne,&nb,&nm,&nl,
&ndime, &nstr, &nbe, &kmax,&nmax, &iln);
*ne_orig = ne;
printf("ne = %5d\n",ne);
fclose(fl1);

if((fl2 = fopen("i.dec","w")) == (FILE *) NULL)
{printf("cannot open i.dec\n"); exit(1);}
fprintf(fl2,"%5d            %5d\n",1,ne);
for(i = 0; i < ne; i++)
fprintf(fl2,"%5d %5d\n",i+1, i+1);
fclose(fl2);
}

void form_decomp_dec(int ne_orig)
{
FILE *ff,*ff1;
char bf[256];
register i,j;
int dum, ne_sd;

ne_sd = ne_orig/t_sds + UnBalance; /* get an etimate on the no of
				   element in each subdomain */

if((elems_sd = calloc(ne_sd,sizeof(int))) == NULL)
{printf("cannot allocate for elems_sd in form_decopm_dec\n");exit(1);}
if((elem_sdno = calloc(ne_orig, sizeof(int))) == NULL)
{printf("cannot allocate for elem_sdno in form_decopm_dec\n");exit(1);}

if((ff= fopen("o.dec","r")) == (FILE *) NULL)
{printf("cannot open o.dec for reading in form_decomp_dec()\n");exit(1);}
if((ff1= fopen("decomp.dec","w")) == (FILE *) NULL)
{printf("cannot open decomp.dec for reading in form_decomp_dec()\n");exit(1);}

for(i = 0;  i < t_sds; i++)
{
     fgets(bf,256,ff); sscanf(bf,"%d %d", &dum, &ne_sd);

     for(j = 0; j < ne_sd; j++)
     {
     fgets(bf,256,ff);
     sscanf(bf,"%d %d", &dum,&(elems_sd[j]));
     }

     load_elem_sdno(i, ne_sd);

}
free(elems_sd);
fclose(ff);

for(i = 0; i < ne_orig; i++)
fprintf(ff1,"%f\n",(float) elem_sdno[i]);

fclose(ff1);
free(elem_sdno);
}

void load_elem_sdno(register i, int ne_sd)
{
register j, pos;

for(j = 0;j < ne_sd; j++) {
pos = elems_sd[j]-1;
elem_sdno[pos] = i+1;
}

}

void node_para_err(char *file_sav)
{
char bf[70];
FILE *fme,*fmen;
int i,j,k, nnn[3];
double xx[3], yy[3], del[3];
/* function generates the node paras and reads elem errors.
   A file with extension .men is generated which has a the
   following format :-
   header line ******************
   1   node para_1
   .       .
   nn  node para_nn
   header line ******************
   1  predicted no of elemnts err_1
   .                            .
   ne                         err_ne
   header line  *****************
   1  elem size hi_1
   .             .
   ne           hi_ne
			       */



   if((sort=calloc(9*nn,sizeof(int)))==NULL)
   {printf("out of memory for sort[]\n");exit(1);}



   search_node();

   if((hi=calloc(ne,sizeof(double)))==NULL)
   {printf("out of memory for hi[]\n");exit(1);}

   if((hhi=calloc(nn,sizeof(double)))==NULL)
   {printf("out of memory for hhi[]\n");exit(1);}

   if((err=calloc(ne,sizeof(double)))==NULL)
   {printf("out of memory for ne\n");exit(1);}

   strcpy(bf, file_sav);strcat(bf,".me");
   if((fme=fopen(bf,"r"))==(FILE *) NULL)
   {printf("cannot open %s\n", bf);exit(1);}

   for(i = 0; i < ne; i++)      /* read in *.me */
   {fgets(bf,70,fme); sscanf(bf,"%d %lf", &j, &hi[i]);}
   fclose(fme);

   /* avg the hi values w.r.t. the connecting elements */
   for(i = 0; i < nn; i++)
   {
       for(j = 0; (k = sort[7*i+j]) != 0 ; j++)
       hhi[i] += hi[k-1];

       if(j == 0)
       continue;

       hhi[i] = hhi[i]/(double) j;

   }

   free(sort);


   strcpy(bf, file_sav);strcat(bf,".men");
   if((fmen=fopen(bf,"w"))==(FILE *) NULL)
   {printf("cannot open %s\n", bf);exit(1);}

   fprintf(fmen,"node paras hhi[]\n");        /* header line */
   for(i = 0; i < nn; i++)
   fprintf(fmen,"%3d    %lf\n",i+1,hhi[i]);



   fprintf(fmen,"predicted nelem err[]\n");      



   for(i = 0; i < ne; i++)
   {
   elemcord_del(i, nnn, xx, yy, del);
   err[i] = neuron(xx, yy, del);
   if(err[i] <= 0.) err[i] = 1.;
   fprintf(fmen,"%3d    %lf\n",i+1, err[i]);
   }

   fprintf(fmen,"elem sizes hi[]\n");           

   for(i = 0; i < ne; i++)
   {
   fprintf(fmen,"%3d    %lf\n",i+1, hi[i]);
   }

   fclose(fmen);

   strcpy(bf, file_sav); strcat(bf,".men");

   copy(bf,"i.men");
}



void search_node(void)
{

   int i,j,k,l;
   for(i=0; i < nn; i++)
      for(j=0; j < 7; j++)
       sort[7*i+j]= 0;

/* Begin searching and sorting the elements connecting to a node,
at a time */


   for(i=0; i < nn; i++)
   {
    l=0;
      for(j=0; j < ne; j++)
      {
	  for(k=0; k < 3; k++)
	  {
	     if((i+1) == nod[4*j+k])
	     {
	      sort[7*i+l]= j+1;
	      l++;
	      break;
		 }
	  }
      }
   }              

return;
}

void rinput_init(char *file)
{
FILE *finp;
char bf[256];
int i,j,k,n;
double x1,y1,z1;

   strcpy(bf,file);
   strcat(bf,".dat");
   if((finp=fopen(bf,"r"))==(FILE *)NULL)
   {printf("cannot open %s\n",bf); exit(1);}

   fgets(bf,50,finp);
   fgets(bf,256,finp);
   fgets(bf,256,finp);
   sscanf(bf,"%d %d %d %d %d %d %d %d %d %d %d",&nn,&ne,&nb,&nm,&nl,
   &ndime, &nstr, &nbe, &kmax,&nmax, &iln);

   fgets(bf,256,finp);
   sscanf(bf,"%d",&nq);

   if((cord = calloc(3*nn, sizeof(double))) == NULL)
   {printf("out of core for cord\n"); exit(1);}
 
   if((nod = calloc(4*ne, sizeof(int))) == NULL)
   {printf("out of core for nod\n"); exit(1);}

   for(i = 0; i < nn; i++)
   {
   fgets(bf,256,finp);
   sscanf(bf,"%d %lf %lf %lf",&n, &x1, &y1,&z1);
   cord[3*i] = x1;
   cord[3*i + 1] = y1;
   cord[3*i + 2] = z1;
   }



   if(ne > 0)
   {
      for(i = 0; i < ne; i++)
      {
	  fgets(bf,256,finp);
      sscanf(bf,"%d %d %d %d %d",&n,&nod[4*i + 0],&nod[4*i + 1],
      &nod[4*i + 2],&nod[4*i + 3]);
      }
   }

fclose(finp);
}



void form_boun(void)
{
register i;

bsgt = 0; /* global variable */


for(i = 0; i < ne; i++)
compare_and_stack(i);

}


void compare_and_stack(int i)
{
register j,k,l,m,n;
int  nd1, nd2, nf1, nf2, knt;

for(k = 0; k < 3; k++)
{
l = k+1; if(l>2) l = 0;
nd1 = nod[4*i+k];  nd2 = nod[4*i+l];

knt = 0;
  for(j = 0; j < ne; j++)
  {
  if(i == j) continue;

      for(m = 0; m < 3; m++)
      {
      n = m+1; if(n>2) n = 0;
      nf1 = nod[4*j+m]; nf2 = nod[4*j+n];
      if((nf1 == nd1 && nf2 == nd2) || (nf2 == nd1 && nf1 == nd2))
      {knt++; break;}
      }

  }
if(knt == 0)
stack_seg(nd1, nd2);
}

}


void stack_seg(int nd1, int nd2)
{
register i,j;

for(i = 0; i < bsgt; i++)
{
if((nd1 == seg[2*i+0] && nd2 == seg[2*i+1]) ||
   (nd2 == seg[2*i+0] && nd1 == seg[2*i+1]))
return;
}
seg[2*bsgt+0] = nd1;
seg[2*bsgt+1] = nd2;
bsgt++;
}

void filer(int flag, int choice, FILE **fp, FILE **fp2, FILE **fp3, FILE **fp4,
	   FILE **fp5, FILE **fp6)
{
if(flag == 0)
{
if((*fp = fopen("i.dat","r")) == (FILE *) NULL)
{printf("cannot open i.dat(r)\n"); exit(1);} 
if((*fp2 = fopen("o.dat","w")) == (FILE *) NULL)
{printf("cannot open o.dat(w)\n"); exit(1);} 

if((*fp3 = fopen("i.dec","r")) == (FILE *) NULL)
{printf("cannot open i.dec(r)\n"); exit(1);}
if((*fp4 = fopen("o.dec","w")) == (FILE *) NULL)
{printf("cannot open o.dec(w)\n"); exit(1);}

if(choice){
if((*fp5 = fopen("i.men","r")) == (FILE *) NULL)
{printf("cannot open i.men(r)\n"); exit(1);}
if((*fp6 = fopen("o.men","w")) == (FILE *) NULL)
{printf("cannot open o.men(w)\n"); exit(1);}
}
}
else
{
if((*fp = fopen("o.dat","r")) == (FILE *) NULL)
{printf("cannot open o.dat(r)\n"); exit(1);} 
if((*fp2 = fopen("i.dat","w")) == (FILE *) NULL)
{printf("cannot open i.dat(w)\n"); exit(1);}

if((*fp3 = fopen("o.dec","r")) == (FILE *) NULL)
{printf("cannot open o.dec(r)\n"); exit(1);}
if((*fp4 = fopen("i.dec","w")) == (FILE *) NULL)
{printf("cannot open i.dec(w)\n"); exit(1);}

if(choice){
if((*fp5 = fopen("o.men","r")) == (FILE *) NULL)
{printf("cannot open i.men(r)\n"); exit(1);}
if((*fp6 = fopen("i.men","w")) == (FILE *) NULL)
{printf("cannot open o.men(w)\n"); exit(1);}
}
}

}
