#define Sub   1
#define Maxop 200L
#define Maxj  100L
#define Nblock 3
#define Nval   4
/*Translated by FOR_C, v3.2 (-), on 03/19/92 at 17:20:50 */
/*FOR_C Options SET: alloc=2 c=2 do=r ftn=lvk op=i s=dv str=l */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include"fcrt.h"
#include <time.h>
/* INPUT PARAMETERS TO  DRV
 *
 * OP:      MATRIX MULTIPLY SUBROUTINE.  IN THE FIRST TWO CALLS THIS
 *          JUST MULTIPLIES BY A.
 *
 * IOVECT:  SUBROUTINE FOR STORING LANCZOS VECTORS.  THE ONE USED
 *          HERE STORES THE VECTORS IN CORE.
 *
 * N:       THE DIMENSION OF THE MATRIX
 *
 * NVAL:    IF -ve then (FIND THE SMALLEST EVALS) USED IN DNLASO ONLY.
 *
 *
 * NFIG:    THE NUMBER OF DECIMAL DIGITS OF ACCURACY REQUESTED IN
 *          THE EIGENVALUES (5 IN ALL CASES).
 *
 * NPERM:   THE NUMBER OF KNOWN EIGENPAIRS ON ENTRY (ZERO IN ALL CASES).
 *
 * NMVAL:   THE ROW DIMENSION OF VAL (10 IN ALL CASES).
 *
 * VAL:     ARRAY THAT RETURNS EIGENVALUES AND ERROR ESTIMATES.
 *
 * NMVEC:   ROW DIMENSION OF VEC (110 IN ALL CASES).
 *
 * MAXVEC:  COLUMN DIMENSION OF VEC (10, USED ONLY BY DILASO).
 *
 * VEC:     ARRAY THAT RETURNS THE EIGENVECTORS.
 *
 * NBLOCK:  THE BLOCK SIZE (SET TO THREE IN ALL CASES)
 *
 * MAXOP:   THE MAXIMUM NUMBER OF MATRIX MULTIPLIES ALLOWED BEFORE
 *          TERMINATION.  (SET TO 40 IN ALL CASES).
 *
 * MAXJ:    THE MAXIMUM SIZE OF A KRYLOV SUBSPACE USED (SEE WORK)
 *          SET TO 50 IN ALL CASES.
 *
 * WORK:    WORK SPACE.  THE FIRST N*NBLOCK LOCATIONS ARE SET TO
 *          THE STARTING VECTORS.  IN ALL CASES THE FIRST VECTOR
 *          IS SET TO ALL 1'S AND THE OTHER TWO ARE SET TO ZERO
 *          TO BE REPLACED BY RANDOM VECTORS.  THE MINIMUM SIZE
 *          OF WORK IS
 *
 *          NBLOCK*(3*N + 2*NBLOCK) + MAXJ*(3*NBLOCK + ABS(NVAL) + 6)
 *          + 3*ABS(NVAL)
 *
 *
 * IND:     INTEGER WORK ARRAY.
 *
 * IERR:    ERROR RETURN CODE.
 *
 * */
#include"fcio.h"

	/* COMMON translations */

struct t_bb {
	LOGICAL32 bool[6];
	}       bb;
#if Sub
extern short *A, *AL, *I, *J;
extern int n_compact;
#else
float *A;
#endif

double *qs;

	/* end of COMMON translations */


char bf[1000];

unsigned kntt = 0;

#if Sub
void drv1(int argc, char *argv[], long  n, double E[], double V[] )
#else
main( argc, argv )
int argc; char *argv[];
#endif
{
FILE *fp;
#if Sub
#else
static long n;
#endif
static long int i, i_, ierr, *ind, j, maxj, maxop, nblock, 
	 nfig, nmval, nmvec, nperm, nval, wksp, wk1, wk2, wk;
static double val[4][10], *vec, *work;
void dnlaso(), iovect(), op();
#define NALLOC  5
void *_alloc[NALLOC];
static F77FMT _fmts[] = {
	1000,   "(//'1 IERR =',i5,'   NUMBER OF MATRIX ACCESSES =',i6)",
	2000,   "(//7x,'  EIGENVALUE',10x,'RESIDUAL NORM',2x,'VALUE ERROR',4x,\
'VECTOR ERROR'//(d25.15,3d15.5))",
	3000,   "(//' THE CORRESPONDING EIGENVECTORS'//4(1x,d12.3))",
	0L,"" };


	f77_ini(argc,argv);

#if Sub
#else
    if((fp=fopen("f02abf.dat","r")) == (FILE *) NULL)
    {printf("cannot open f02abf.dat\n"); exit(1);}
    fgets(bf,1000,fp); 
    fgets(bf,1000,fp); 
    sscanf(bf,"%ld",&n);
#endif
    if(kntt == 0)
    {
    vec = (double*)(_alloc[0]=malloc(10*(n+10)*sizeof(double)));
    wksp=2*n*Nblock+Maxj*(Nblock+Nval+2)+2*Nblock*Nblock + 3*Nval;
    wk1 = n*Nblock;
    wk2 = Maxj*(2*Nblock+3)+2*Nval+6+(2*Nblock+2)*(Nblock+1);
    wk = (wk1 > wk2) ? wk1 : wk2;
    wksp += wk;
    work = (double*)(_alloc[1]=malloc(wksp*sizeof(double)));
    ind = (long *)(_alloc[2]=malloc((20+n)*sizeof(long)));
    qs  = (double*)(_alloc[3]=malloc(50*(n+10)*sizeof(double)));
#if Sub
#else
    A   = (float*)(_alloc[4]=malloc(n*n*sizeof(double)));
#endif
    ck_allocs(_alloc, NALLOC, "prgm_");
    kntt++;
    }

#if Sub
#else
    for(i=0; i < n; i++)
    for(j = 0; j < n; j++)
    fscanf(fp,"%lf",&A[n*i+j]);
#endif

	/* SET THE FIXED PARAMETERS
	 *      N=100 */
	nfig = 5L;
	nmval = 10L;
	nmvec = (n+10L);
	nblock = 3L;
	maxop = Maxop;
	maxj = Maxj;

	/* SET PARAMETERS FOR CALL TO DNLASO */
	nval = 4L;
	nperm = 0L;

	/* SET STARTING VECTORS */
	for( i = 1L; i <= n; i++ ){
		i_ = i - 1;
		work[i_] = 1.0e0;
		work[n + i_] = 0.0e0;
		work[2L*n + i_] = 0.0e0;
		}

	/* CALL DNLASO */
	dnlaso( op, iovect, &n, &nval, &nfig, &nperm, &nmval, val, &nmvec, 
	 vec, &nblock, &maxop, &maxj, work, ind, &ierr );

#if Sub
    /* load E[] and V[]*/
    for(j = 0L; j < nperm; j++)
    E[j] = val[0][j];          /* load nperm eigen values found */

    for(j = 0L; j < n; j++)
    V[j] = vec[nmvec*1L+j];       /* load the 2nd largest eigen vector */
#endif

	/* WRITE OUTPUT */
	open_unit(16, "LASO.OUT", "UNKNOWN", "", "", 0);
	wrt_seqbeg(16, FMTR(1000));
	wrtfmt( 16, "%ld %ld \n", ierr, ind[0L] );
	wrt_seqbeg(16, FMTR(2000));
	for( i = 1L; i <= nperm; i++ ){
		for( j = 1L; j <= 4L; j++ ){
			wrtfmt( 16, "%g ", val[j - 1L][i - 1L] );
			}
		}
	wrtfmt( 16, "\n" );
	wrt_seqbeg(16, FMTR(3000));
	for( i = 1L; i <= n; i++ ){
		for( j = 1L; j <= nperm; j++ ){
			wrtfmt( 16, "%g ", vec[nmvec*(j - 1L) + i - 1L] );
			}
		}
	wrtfmt( 16, "\n" );
    printf("laso.out generated for iteration=%3d\n",kntt);

#undef NALLOC
#if Sub
#else
return(1);
#endif

} /* end of function */




void /*FUNCTION*/ op(n, m, p, q)
long int *n, *m;
double *p, *q;
{
FILE *fd;
#define P(I_,J_)        (*(p+(I_)*(*n)+(J_)))
#define Q(I_,J_)        (*(q+(I_)*(*n)+(J_)))
static int count;
static long int i, i_, j, j_, k, k_, jj;
static float sum;
time_t t1, t2;

/*
    if(knt == 0)
    if((fd=fopen("test.dat","w")) == NULL)
    {printf("cannot open test.dat\n"); exit(1);} */

	/* THIS IS THE MATRIX MULTIPLY FOR THE MATRIX A. */
time(&t1);
/*
	for( i = 1L; i <= *n; i++ ){
		i_ = i - 1;
		for( j = 1L; j <= *m; j++ ){
			j_ = j - 1;
			sum = 0.;
			for( k = 1L; k <= *n; k++ ){
				k_ = k - 1;
				sum = sum + A[(*n)*k_+i_]*P(j_,k_);
				}
			Q(j_,i_) = sum;
			}
		}

*/

/*
if(knt == 0)
print_mat(fd, *m, *n, q);
*/

for(i = 0; i < *n; i++) for(j = 0; j < *m; j++) Q(j,i) = 0.;

for(jj = 0; jj < *m; jj++)
{
   for(i = 0; i < n_compact; i++)
   {
   i_ = I[i];
   j_ = J[i];
   Q(jj,i_) +=  AL[i]*P(jj,j_);
   }
continue;
}
/*
if(knt == 0)
print_mat(fd, *m, *n, q);
knt++;
*/

time(&t2);
/*
printf("test.dat generated\n");
fclose(fd); */
    printf("mult = %d time %d sec\n", ++count, t2-t1);
	return;
#undef  Q
#undef  P

} /* end of function */



void /*FUNCTION*/ iovect(n, m, q, j, k)
long int *n, *m;
double *q;
long int *j, *k;
{
#define Q(I_,J_)        (*(q+(I_)*(*n)+(J_)))
static long int i, i_, l, l1, l_;



	/* THIS SUBROUTINE STORES AND RECALLS VECTORS.  IT STORES THE VECTORS
	 * IN CORE ALTHOUGH MOST REAL PROBLEMS WOULD USE A DISK. */
	if( *k == 1L )
		goto L_30;
	for( l = 1L; l <= *m; l++ ){
		l_ = l - 1;
		l1 = *j - *m + l;
		for( i = 1L; i <= *n; i++ ){
			i_ = i - 1;
			qs[(*n+10)*(l1 - 1L)+i_] = Q(l_,i_);
			}
		}
/*      free(qs);*/
	return;

L_30:
	for( l = 1L; l <= *m; l++ ){
		l_ = l - 1;
		l1 = *j - *m + l;
		for( i = 1L; i <= *n; i++ ){
			i_ = i - 1;
			Q(l_,i_) = qs[(*n+10)*(l1 - 1L)+i_];
			}
		}
/*      free(qs);*/
	return;
#undef  Q
} /* end of function */

/*
print_mat(FILE *fd, int nrow, int ncol, double *mat)
{
register i,j;

for(i = 0; i < nrow; i++)
{
   for(j = 0; j < ncol; j++)
   fprintf(fd," %5.1f", mat[ncol*i+j]);
fprintf(fd,"\n");
}
}
*/